//
// ScrPlus
// (c) 1996-2000 Lucian Wischik. All rights reserved
//

#define WIN32_LEAN_AND_MEAN
#define STRICT

#include <windows.h>
#include <commctrl.h>
#include <custcntl.h>
#include <stdio.h>
#include <process.h>
#pragma hdrstop

#include "..\include\scrapi.h"
#include "..\include\scrplus.rh"
#include "..\include\scrplus.h"


#ifndef __BORLANDC__
#ifndef _MSC_VER
#pragma message FATAL ERROR: COMPILATION ON AN UNEXPECTED PLATFORM
#pragma message You'll have to go through the code looking for the
#pragma message problem areas yourself. Do a keyword search for
#pragma message __BORLANDC__ or _MSC_VER to find the problem areas,
#pragma message and correct them
#endif
#endif

// For an explanation of how codes work, see 'codes.txt'

#define SCRM_INTERNAL    SCRM_LAST-1
#define SCRINTERNAL_THREADTIMER 0
#define SCRINTERNAL_HADENOUGH   1
#define SCRINTERNAL_CREATETIMER 2

#define MonitorWindowClassName "ScrplusMonitorWindowClass"
#define MonitorClassDesc "Monitor"
// kept private in here

#define SaverClassName "LuScreenSaverClass"
// SaverClass is used for normal-mode of doing things
#define DefSaverClassName "DummyScreenSaverClass"
// DefSaverClass is a dummy that is passed as the default to the Ex create things.
// It would be a bit dumb to use it, though.
#define ID_ABOUT 3500
// ID_ABOUT is for the system menu


// The previous release of ScrPlus existed as a DLL. This one is LIB
// only. Therefore, when things refer to hDllInstance &c., they
// probably don't really mean that.
// Remember! DLL global variables are normally just global to the application:
// the default behaviour is for each process that uses the DLL, to have its
// own copy of all the DLL's global variables.

HINSTANCE hDllInstance=NULL;


#define TIMERDATA_PROPNAME ("PROP_SCRPLUSTIMERDATA")

//const char actionchar[]=  {action_default_char,action_now_char,action_never_char};
const unsigned int menucorner[]= {0x1000,0x1100,0x1200,0x1300};
#define menu_getindex  0x00FF
#define menu_getcorner 0x0F00

static DWORD GeneralHelpIds[] = {
  ID_DISMISSGROUP, SCRHELP_THRESHOLD,
  ID_THRESHOLDDESC, SCRHELP_THRESHOLD,
  ID_THRESHOLD, SCRHELP_THRESHOLD,
  ID_WAITDESC, SCRHELP_PASSWORDDELAY,
  ID_WAITTEXT, SCRHELP_PASSWORDDELAY,
  ID_WAITBUDDY, SCRHELP_PASSWORDDELAY,
  ID_WAITBOX, SCRHELP_PASSWORDDELAY,
  ID_WAITMOREDESC, SCRHELP_PASSWORDDELAY,
  ID_SAGEOK, SCRHELP_CORNERS,
  ID_SAGEBAD, SCRHELP_CORNERS,
  ID_MONITOR,SCRHELP_CORNERS,
  ID_MUTE, SCRHELP_MUTE,
  ID_ACTIVECONFIG, SCRHELP_ACTIVECONFIG,
  0,0
};


// These global things are loaded for the lifetime of the process
RECT rc[4];
RECT rcscreen;
HMENU menu[4];
HBITMAP bmmonitor;
HBITMAP bmaction[3];
SIZE monitorsize;
SIZE actionsize;
BOOL sageok;        // both sageok and givenwarning are stored globally
BOOL givenwarning;
typedef struct tagThreadList { HANDLE hThread; tagThreadList *next;} TThreadList;
CRITICAL_SECTION ThreadCounterCritSec;
TThreadList *ThreadList=NULL;

// Monitor stuff
void MonitorCreate(HWND);
void MonitorCommand(HWND,int);
void MonitorLButtonDown(HWND,int,int);
void MonitorPaint(HWND);


// Stuff for controlling the lifetime of the DLL process
BOOL WINAPI DllEntryPoint(HINSTANCE,DWORD,LPVOID);
BOOL InitProcess();
BOOL CloseProcess();
BOOL RegisterControls();
BOOL UnregisterControls();
void LibInit();
void LibClose();
BOOL IsADll=FALSE;
void CheckResources();


// Stuff for the way the current process is using the DLL.
// Note: we impose the restriction that a process can be running only
// one ExecuteScreenSaver at a time.
// The various forms of execute set up these common fields, and then call
// a common execute with their particular type of procedures
BOOL isrunning=FALSE;
TScrPrefs prefs;
BOOL hassetprefs=FALSE;
void SetDefaultPrefs();
BOOL isregistered=FALSE;
int numregistrations=0;
BOOL islibinit=FALSE;
BOOL hasfailedlibinit=FALSE;
BOOL x_supplied_about=FALSE;
BOOL n_supplied_about=FALSE;
SCREENSAVERPROC *n_screensaverproc;
SCREENSAVERCONFIGUREDIALOG *n_screensaverconfiguredialog;
REGISTERDIALOGCLASSES *n_registerdialogclasses;
SCREENSAVERCHANGEPASSWORD *n_screensaverchangepassword;
LUCREATESAVER *x_lucreatesaver;
LUCONFIG *x_luconfig;
LUABOUT *x_luabout;
LUCHANGEPASSWORD *x_luchangepassword;
HWND w_hwnd;
// And the following are all common
typedef HWND (CREATEPREVIEWPROC) (HWND hParent, BOOL ismainpreview);
typedef HWND (CREATEFULLPROC) ();
typedef HWND (CREATESAVERPROC) (BOOL, WNDCLASS &);
typedef int  (CONFIGPROC) (HWND hParent, PROPSHEETHEADER &);
typedef int  (ABOUTPROC) (HWND hParent);
typedef int  (CHANGEPASSWORDPROC) (HWND hParent);
CREATEPREVIEWPROC *p_createpreview;
CREATEFULLPROC *p_createfull;
CREATESAVERPROC *p_createsaver;
CONFIGPROC *p_config;
ABOUTPROC *p_about;
CHANGEPASSWORDPROC *p_changepassword;
// The following are prototypes for the stock common functions
CREATEPREVIEWPROC NCreatePreview;
CREATEPREVIEWPROC XCreatePreview;
CREATEPREVIEWPROC WCreatePreview;
CREATEFULLPROC NCreateFull;
CREATEFULLPROC XCreateFull;
CREATEFULLPROC WCreateFull;
CONFIGPROC NConfig;
CONFIGPROC XConfig;
CONFIGPROC WConfig;
ABOUTPROC NAbout;
ABOUTPROC XAbout;
ABOUTPROC WAbout;
CHANGEPASSWORDPROC NChangePassword;
CHANGEPASSWORDPROC XChangePassword;
CHANGEPASSWORDPROC WChangePassword;
// and this is where we go to do the common functions
HINSTANCE hScrInstance;
int ExecuteScreenSaver(HINSTANCE,CREATEPREVIEWPROC *,CREATEFULLPROC *,CONFIGPROC *,ABOUTPROC *,CHANGEPASSWORDPROC *);
int ScrMain();
HWND CheckForScrprev(LPSTR);
void ScrDebugString(char *c);
void ScrDebugString(char *,char *);
void ScrDebugBox(HWND,char *,char *);

// Prototypes for functions that do the stuff in response to the command line
int DoFullSave();
int DoPreview(HWND);
int DoChangePasswdDialog(HWND);
int DoConfigDialog(HWND hparwnd, BOOL isactive);
// and this is just a default behaviour of the password checker
int DoVerifyPwDialog(HWND);
BOOL NeedPassword();

// Stuff for the main full-screen saver window
typedef struct {POINT orig; DWORD starttime; BOOL isdialogactive;
       DWORD passworddelay; unsigned int mousethreshold;
       BOOL activeconfig;
} TScrWindowParams;
// Only one fwp can exist in the process context at a time.
TScrWindowParams fwp;

// Used for notifying all preview windows
void BroadcastChildMonitors(HWND,TScrChangeRouter *);

// This default procedure is used as a wrapper for NConfig, to hide & disable
// the IDOK and IDCANCEL buttons if they happen to be there. This is so that
// old screensavers can be recompiled easily
BOOL CALLBACK TidyupNConfigProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam);


// Prototypes for default configure property sheet stuff
BOOL CALLBACK ScreenSaverConfigureDialog(HWND,UINT,WPARAM,LPARAM);
BOOL CALLBACK GeneralDlgProc(HWND,UINT,WPARAM,LPARAM);
int CALLBACK PropertysheetCallback(HWND,UINT,LPARAM);
LRESULT CALLBACK PropertysheetSubclassProc(HWND,UINT,WPARAM,LPARAM);

class TGeneralSettings { public:
  BOOL ignorechanges;
  TCorners corner,oldcorner;
  BOOL mute,oldmute;
  unsigned int mousethreshold,oldmousethreshold;
  unsigned int mousethresholdindex,oldmousethresholdindex;
  unsigned int passworddelay,oldpassworddelay;
  unsigned int passworddelayindex,oldpassworddelayindex;
  BOOL activeconfig,oldactiveconfig;
  TGeneralSettings();
  void ReadRegistry();   // loads current values from registry
  void WriteRegistry();  // writes all current values to registry
  void NotifyChanges(HWND,BOOL);// informs system that corners have changed
  void Mark();           // remembers current settings
  BOOL Reset();          // reverts to remembered settings
  void SetControls(HWND);// set controls to match current state
  void GetControls(HWND);// read all of controls, and write registry if necessary
};


typedef struct {
  HWND hwnd; // Set at thread creation
  CRITICAL_SECTION critsec; // critsec protects IsHwndValid
  BOOL IsHwndValid; // set to FALSE if the window no longer wishes the thread to do stuff
  HANDLE hChangeEvent; // in response to a SCRM_CHANGE, to interrupt the sleep
#ifdef __BORLANDC__
  unsigned long idThread; // so, if it's there, it can be told to quit
#endif
#ifdef _MSC_VER
  unsigned int idThread;
#endif
  unsigned long hThread; // a handle so we can wait for it
} TThreadData;

// The meaning of TThreadData:
// critsec protects both fields. isHwndValid says whether or not it's
// valid. Obviously, if it isn't, then messages can't be sent to it.
// Normally 'IsHwndValid' will be set to TRUE on thread creation, and set
// to FALSE just before a PostThreadMessage(WM_QUIT) has been sent to the
// thread. IsHwndValid will only ever switch from TRUE to FALSE.
// A TThreadData is created externally before thread creation, and it is
// passed to the thread function, and it is the responsibility of the thread
// function to delete it after having received a WM_QUIT message.
// We use this peculiar protocol just in case the thread spins a few more
// times before it finally gets the WM_QUIT message.
// If ever a thread decides it has had enough, it posts a SCRM_threadhadenough
// message to the main window, and will expect the main window to send it the
// WM_QUIT.

#ifdef __BORLANDC__
void ThreadFunction(void *);
#endif
#ifdef _MSC_VER
unsigned int __stdcall ThreadFunction(void *);
#endif




//////////////////////////////////////////////////////////////////////////////
// OVERALL SETUP FOR DIFFERENT TYPES OF USE OF THE DLL                      //
// -----------------------------------------------------                    //
//////////////////////////////////////////////////////////////////////////////

LPTScrPrefs WINAPI ScrCreatePrefs()
{ LibInit();
  SetDefaultPrefs();
  TScrPrefs *p=new TScrPrefs;
  p->cbSize=sizeof(TScrPrefs);
  p->AllowActiveConfig=prefs.AllowActiveConfig;
  p->AllowMute=prefs.AllowMute;
  p->DisableAbout=prefs.DisableAbout;
  p->DisablePreviewBroadcast=prefs.DisablePreviewBroadcast;
  p->DisableThreadTimer=prefs.DisableThreadTimer;
  p->IsDebug=prefs.IsDebug;
  p->IsTrace=prefs.IsTrace;
  lstrcpyn(p->DynamicCode,prefs.DynamicCode,256);
  lstrcpyn(p->StaticCode,prefs.StaticCode,256);
  p->AlwaysRequirePassword=prefs.AlwaysRequirePassword;
  p->NeverRequirePassword=prefs.NeverRequirePassword;
  p->CheckPasswordForActiveConfig=prefs.CheckPasswordForActiveConfig;
  return p;
}
void WINAPI ScrSetPrefs(TScrPrefs *p)
{ LibInit();
  if (isrunning)
  { ScrDebugString("You are not allowed to set prefs while screensaver is running");
	 ScrDebugBox(NULL,"You are not allowed to set prefs while screensaver is running","Prefs error");
	 return;
  }
  if (p==NULL)
  { ScrDebugString("ScrSetPrefs called with NULL preferences");
	 ScrDebugBox(NULL,"ScrSetPrefs called with NULL preferences","Prefs error");
	 return;
  }
  prefs.AllowActiveConfig=p->AllowActiveConfig;
  prefs.AllowMute=p->AllowMute;
  prefs.DisableAbout=p->DisableAbout;
  prefs.DisablePreviewBroadcast=p->DisablePreviewBroadcast;
  prefs.DisableThreadTimer=p->DisableThreadTimer;
  prefs.IsDebug=p->IsDebug;
  prefs.IsTrace=p->IsTrace;
  lstrcpyn(prefs.DynamicCode,p->DynamicCode,256);
  lstrcpyn(prefs.StaticCode,p->StaticCode,256);
  prefs.AlwaysRequirePassword=p->AlwaysRequirePassword;
  prefs.NeverRequirePassword=p->NeverRequirePassword;
  prefs.CheckPasswordForActiveConfig=p->CheckPasswordForActiveConfig;
  if (prefs.AlwaysRequirePassword && prefs.NeverRequirePassword)
  { ScrDebugString("You have set always-require-password AND never-require-password, which is silly!");
	 ScrDebugBox(NULL,"You have set always-require-password AND never-require-password, which is silly!","Prefs error");
  }
  delete p;
}

// called if we know we're a lib
void CheckResources()
{ HICON hIcon=LoadIcon(hDllInstance,MAKEINTRESOURCE(ICON_SCRAPP));
  BOOL respres=FALSE;
  if (hIcon!=NULL)
  { respres=TRUE; DestroyIcon(hIcon); }
  if (!respres)
  { MessageBox(NULL,"You _MUST_ include the ScrPlus resources (scrplus.res)","ScrPlus",MB_OK);
  }
}


/*
void CheckRegister()
{
  if (!isregistered)
  { if (IsADll)
	 { if (strcmp(prefs.DynamicCode,"")!=0)
		{ isregistered=CheckCode(hScrInstance,prefs.DynamicCode);
		}
		else
		{ if (strcmp(prefs.StaticCode,"")==0)
		  { ScrDebugString("*** Warning: you have not registered, and you will get nag screens. You should set-prefs with DynamicCode set.");
		  }
        else
        { ScrDebugString("*** Warning: you have set the static code, but are linking dynamically. You should set-prefs with DynamicCode set.");
          ScrDebugBox(NULL,"You have set the static code, but are linking dynamically. You should set-prefs with DynamicCode set.","Warning");
        }
      }
    }
    else
    { if (strcmp(prefs.StaticCode,"")!=0)
      { isregistered=CheckCode(hScrInstance,prefs.StaticCode);
      }
      else
		{ if (strcmp(prefs.DynamicCode,"")==0)
        { ScrDebugString("*** Warning: you have not registered, and you will get nag screens. You should set-prefs with StaticCode set.");
        }
        else
        { ScrDebugString("*** Warning: you have set the dynamic code, but are linking statically. You should set-prefs with StaticCode set.");
          ScrDebugBox(NULL,"You have set the dynamic code, but are linking statically. You should set-prefs with StaticCode set.","Warning");
        }
      }
    }
  }
}
*/

void SetDefaultPrefs()
{ if (hassetprefs) return;
  prefs.AllowActiveConfig=FALSE;
  prefs.AllowMute=TRUE;
  prefs.DisableAbout=FALSE;
  prefs.DisablePreviewBroadcast=FALSE;
  prefs.DisableThreadTimer=FALSE;
  prefs.IsDebug=FALSE;
  prefs.IsTrace=FALSE;
  strcpy(prefs.DynamicCode,"");
  strcpy(prefs.StaticCode,"");
  prefs.AlwaysRequirePassword=FALSE;
  prefs.NeverRequirePassword=FALSE;
  prefs.CheckPasswordForActiveConfig=TRUE;
  hassetprefs=TRUE;
}



extern "C" int WINAPI ScrExecute(HINSTANCE h,SCREENSAVERPROC *scp,
												 SCREENSAVERCONFIGUREDIALOG *sscd,
												 REGISTERDIALOGCLASSES *rdc,
												 SCREENSAVERCHANGEPASSWORD *sscp)
{LibInit();
 if (isrunning) return IDCANCEL;
 x_supplied_about=FALSE;
 HRSRC haboutrsr=FindResource(hScrInstance,(LPCTSTR)DLG_ABOUT,RT_DIALOG);
 if (haboutrsr==NULL) n_supplied_about=FALSE; else n_supplied_about=TRUE;
 n_screensaverproc=scp; n_screensaverconfiguredialog=sscd;
 n_registerdialogclasses=rdc; n_screensaverchangepassword=sscp;
 if (rdc!=NULL) (*rdc)(h);  // Might as well register them immediately. Use hScrInstance
 // Also might as well register the screensaver window here.
 // Use the same one for full-screen and preview
 WNDCLASSEX wcs;
 wcs.cbSize=sizeof(wcs);
 wcs.style=CS_VREDRAW | CS_HREDRAW;
 wcs.lpfnWndProc=*scp;
 wcs.cbClsExtra=0;
 wcs.cbWndExtra=0;
 wcs.hInstance=hScrInstance; // instance of the procedure
 wcs.hIcon=NULL;
 wcs.hCursor=NULL;
 wcs.hbrBackground=(HBRUSH)GetStockObject(NULL_BRUSH);
 wcs.lpszMenuName=NULL;
 wcs.lpszClassName=SaverClassName;
 wcs.hIconSm=NULL;
 RegisterClassEx(&wcs);
 return ExecuteScreenSaver(h,NCreatePreview,NCreateFull,NConfig,NAbout,NChangePassword);
}


int WINAPI ScrExecuteEx(HINSTANCE h,LUCREATESAVER *lcs,
											LUCONFIG *lc,
											LUABOUT *la,
											LUCHANGEPASSWORD *lcp)
{LibInit();
 if (isrunning) return IDCANCEL;
 if (la!=NULL) x_supplied_about=TRUE; else x_supplied_about=FALSE;
 n_supplied_about=FALSE;
 x_lucreatesaver=lcs; x_luconfig=lc; x_luabout=la; x_luchangepassword=lcp;
 WNDCLASSEX wcs;
 wcs.cbSize=sizeof(wcs);
 wcs.style=CS_VREDRAW | CS_HREDRAW;
 wcs.lpfnWndProc=DefScreenSaverProc;
 wcs.cbClsExtra=0;
 wcs.cbWndExtra=0;
 wcs.hInstance=hScrInstance; // instance of the procedure
 wcs.hIcon=NULL;
 wcs.hCursor=NULL;
 wcs.hbrBackground=(HBRUSH)GetStockObject(NULL_BRUSH);
 wcs.lpszMenuName=NULL;
 wcs.lpszClassName=DefSaverClassName;
 wcs.hIconSm=NULL;
 RegisterClassEx(&wcs);
 return ExecuteScreenSaver(h,XCreatePreview,XCreateFull,XConfig,XAbout,XChangePassword);
}

int WINAPI ScrExecuteWin(HINSTANCE h,HWND hw)
{LibInit();
 if (isrunning) return IDCANCEL;
 x_supplied_about=FALSE;
 n_supplied_about=FALSE;
 w_hwnd=hw;
 WNDCLASSEX wcs;
 wcs.cbSize=sizeof(wcs);
 wcs.style=CS_VREDRAW | CS_HREDRAW;
 wcs.lpfnWndProc=DefScreenSaverProc;
 wcs.cbClsExtra=0;
 wcs.cbWndExtra=0;
 wcs.hInstance=hScrInstance; // instance of the procedure
 wcs.hIcon=NULL;
 wcs.hCursor=NULL;
 wcs.hbrBackground=(HBRUSH)GetStockObject(GRAY_BRUSH);
 wcs.lpszMenuName=NULL;
 wcs.lpszClassName=DefSaverClassName;
 wcs.hIconSm=NULL;
 RegisterClassEx(&wcs);
 return ExecuteScreenSaver(h,WCreatePreview,WCreateFull,WConfig,WAbout,WChangePassword); }

int ExecuteScreenSaver(HINSTANCE h,
                       CREATEPREVIEWPROC *cpp,
                       CREATEFULLPROC *cfp,
                       CONFIGPROC *cp,
                       ABOUTPROC *ap,
                       CHANGEPASSWORDPROC *chpp)
{ isrunning=TRUE;
  p_createpreview=cpp; p_createfull=cfp; p_config=cp;
  p_about=ap; p_changepassword=chpp;
  hScrInstance=h;
  //CheckRegister();
  //Nag();
  if (prefs.DisableThreadTimer) ThreadList=NULL;
  else
  { ThreadList=NULL;
    InitializeCriticalSection(&ThreadCounterCritSec);
  }
  int res=ScrMain();
  isrunning=FALSE;
  if (!IsADll) LibClose();
  if (ThreadList!=NULL)
  { int i=0;
    EnterCriticalSection(&ThreadCounterCritSec);
    TThreadList *tl=ThreadList;
    while (tl!=NULL) { i=i+1; tl=tl->next; }
    HANDLE *thandles=new HANDLE[i];
    i=0; tl=ThreadList;
    while (tl!=NULL) {thandles[i]=tl->hThread; i++; tl=tl->next; }
    LeaveCriticalSection(&ThreadCounterCritSec);
    DWORD res=WaitForMultipleObjects(i,thandles,TRUE,10000);
    delete[] thandles;
    if (res==WAIT_TIMEOUT)
    { ScrDebugString("Not all threads have terminated!");
      ScrDebugBox(NULL,"Not all threads have terminated","ThreadTimer error");
    }
    EnterCriticalSection(&ThreadCounterCritSec);
    while (ThreadList!=NULL)
    { TThreadList *tl=ThreadList->next;
      delete ThreadList;
      ThreadList=tl;
    }
    LeaveCriticalSection(&ThreadCounterCritSec);
  }
  return res;
}










//////////////////////////////////////////////////////////////////////////////
// MAIN EXECUTION                                                           //
// ----------------                                                         //
//////////////////////////////////////////////////////////////////////////////

int ScrMain()
{ char *c=GetCommandLine(); if (c==NULL) return IDCANCEL;
  BOOL isconfig=FALSE, ispreview=FALSE, ispasswd=FALSE, isfull=FALSE;
  HWND hparwnd=NULL;
  // First, get the pointer past the first argument
  if (*c=='"')
  { c++; c=strchr(c,'"'); if (c==NULL) return IDCANCEL; c++; }
  else
  { while (*c!=' ' && *c!=0) c++; }
  while (*c==' ') c++;
  // Now, it might be NULL or the start of an argument
  if (*c==0)
  { isconfig=TRUE; hparwnd=NULL; }
  else
  { // Here we have at least some arguments
    if (*c=='-') c++;
    if (*c=='/') c++;
    switch (*c) {

      case 'p': case 'P': case 'l': case 'L':
      { hparwnd=CheckForScrprev(c);
		  if (hparwnd!=NULL) ispreview=TRUE;
        else
        { c++; while (*c==' ' || *c==':') c++;
          if (*c==0) return IDCANCEL;
          int val;
          if (strcmp(c,"")!=0)
          { int res=sscanf(c,"%i",&val);
            if (res>0)
            { hparwnd=(HWND)val;
              if (IsWindow(hparwnd)) ispreview=TRUE; else return IDCANCEL;
            }
          }
        }
      } break;

      case 'c': case 'C': {isconfig=TRUE; hparwnd=GetForegroundWindow(); } break;

      case 's': case 'S': {isfull=TRUE;} break;

      case 'a': case 'A':
      { c++; while (*c==' ' || *c==':') c++;
        BOOL foundwnd=FALSE;
        if (*c==0) {foundwnd=FALSE;}
        else
        { int val;
			 int res=sscanf(c,"%i",&val);
          if (res>0) { hparwnd=(HWND)val; foundwnd=IsWindow(hparwnd); }
        }
        if (!foundwnd) hparwnd=GetForegroundWindow();
        ispasswd=TRUE;
      } break;

    }
  }
  if (isfull) return DoFullSave();
  if (ispreview) return DoPreview(hparwnd);
  if (ispasswd) return DoChangePasswdDialog(hparwnd);
  if (isconfig) return DoConfigDialog(hparwnd,FALSE);
  return IDCANCEL;
}


//
// CheckForScrprev
// If it finds that the command line argument is indeed 'p scrprev'
// then it finds the scrprev window so it can be a child of it.
// It uses STR_LUSCRPREV as the title 'scrprev' to look for and load
//
HWND CheckForScrprev(LPSTR c)
{ char cScrprev[100], cError[200], cTitle[100];
  char tmp[100];
  int res=LoadString(hDllInstance,STR_LUSCRPREV,cScrprev,99);
  if (res==0) return NULL;
  strcpy(cTitle,cScrprev); // cTitle preserves case, for messageboxes
  CharLowerBuff(cScrprev,strlen(cScrprev));
  strcpy(tmp,c);
  char *startd=tmp; startd++;
  while (*startd==' ') startd++;
  char *endd=tmp; while (*endd!=' ' && *endd!=0) endd++; *endd=0; // trim it
  CharLowerBuff(startd,strlen(startd));
  if (strcmp(startd,cScrprev)!=0) return NULL;
  // So now we know that the user did have /Scrprev
  HWND hwnd;
  hwnd=FindWindow(cScrprev,NULL);
  if (hwnd==NULL)
  { // try to load it
    STARTUPINFO si; PROCESS_INFORMATION pi; si.cb=sizeof(si);
    si.lpReserved=NULL; si.lpTitle=NULL; si.dwFlags=0; si.cbReserved2=0; si.lpReserved2=0;
    // We pass cScrprev twice because otherwise it doesn't work
    BOOL cres=CreateProcess(cScrprev,cScrprev,0,0,FALSE,CREATE_NEW_PROCESS_GROUP | CREATE_DEFAULT_ERROR_MODE,0,0,&si,&pi);
    if (!cres)
	 { res=LoadString(hDllInstance,STR_LUSCRPREVCREATEERROR,cError,199);
      if (res>0) ::MessageBox(NULL,cError,cTitle,MB_OK);
      return NULL;
    }
    DWORD wres=WaitForInputIdle(pi.hProcess,2000);
    if (wres==WAIT_TIMEOUT)
    { res=LoadString(hDllInstance,STR_LUSCRPREVTIMEOUT,cError,199);
      if (res>0) ::MessageBox(NULL,cError,cTitle,MB_OK);
      return NULL;
    }
    if (wres==0xFFFFFFFF)
    { res=LoadString(hDllInstance,STR_LUSCRPREVWAITERROR,cError,199);
      if (res>0) ::MessageBox(NULL,cError,cTitle,MB_OK);
      return NULL;
    }
    hwnd=FindWindow(cScrprev,NULL);
    if (hwnd!=NULL) SetForegroundWindow(hwnd);
  }
  if (hwnd==NULL)
  { res=LoadString(hDllInstance,STR_LUSCRPREVNOTFOUND,cError,199);
    if (res>0) ::MessageBox(NULL,cError,cTitle,MB_OK);
    return NULL;
  }
  // Note: it's actually the child that we want
  hwnd=GetWindow(hwnd,GW_CHILD);
  if (hwnd==NULL)
  { res=LoadString(hDllInstance,STR_LUSCRPREVNOCHILD,cError,199);
    if (res>0) ::MessageBox(NULL,cError,cTitle,MB_OK);
    return NULL;
  }
  return hwnd;
}









// DoConfigDialog:
int DoConfigDialog(HWND hwnd,BOOL isactive)
{ ScrDebugString("ScrPlus: DoConfigDialog: starting...");
  CheckResources();
  // We could check to see if the settings dialog was already up, and if so
  // foreground it. This would involve mutexes, and I can't be bothered
  // The reason would be so that if you clicked on 'settings', and had already
  // launched settings elsewhere, we could do with having only one.
  TScrDialogInfo di;
  di.IsAnActiveDialog=isactive;
  int res=DialogBoxParam(hDllInstance,MAKEINTRESOURCE(DLG_INVISIBLEPARENT),
       hwnd,ScreenSaverConfigureDialog,(LPARAM)&di);
  ScrDebugString("ScrPlus: ~DoConfigDialog.");
  return res;
}



TGeneralSettings::TGeneralSettings()
{ corner[corner_nw]=action_default; corner[corner_ne]=action_default;
  corner[corner_se]=action_default; corner[corner_nw]=action_default;
  mute=FALSE; mousethreshold=0; mousethresholdindex=0;
  passworddelay=60; passworddelayindex=0; activeconfig=FALSE;
  ignorechanges=FALSE;
  ReadRegistry(); Mark();
}

void TGeneralSettings::ReadRegistry()
{
  LONG res;
  HKEY skey;
  DWORD valtype, valsize, val;
  char cRegText[100];
  res=LoadString(hDllInstance,STR_REGSAVERSKEY,cRegText,99);
  if (res==0) return;
  res=RegOpenKeyEx(HKEY_CURRENT_USER,cRegText,0,KEY_ALL_ACCESS,&skey);
  if (res!=ERROR_SUCCESS) return;
  // 1. Password delay
  res=LoadString(hDllInstance,STR_REGPASSWORDDELAY,cRegText,99);
  if (res>0)
  { valsize=sizeof(val); res=RegQueryValueEx(skey,cRegText,0,&valtype,(LPBYTE)&val,&valsize);
    if (res==ERROR_SUCCESS) passworddelay=val;
  }
  // 2. Password delay index
  res=LoadString(hDllInstance,STR_REGPASSWORDDELAYINDEX,cRegText,99);
  if (res>0)
  { valsize=sizeof(val); res=RegQueryValueEx(skey,cRegText,0,&valtype,(LPBYTE)&val,&valsize);
    if (res==ERROR_SUCCESS) { if (val>1) val=1; passworddelayindex=val; }
  }
  // 3. Mouse threshold
  res=LoadString(hDllInstance,STR_REGMOUSETHRESHOLD,cRegText,99);
  if (res>0)
  { valsize=sizeof(val); res=RegQueryValueEx(skey,cRegText,0,&valtype,(LPBYTE)&val,&valsize);
    if (res==ERROR_SUCCESS)  mousethreshold=val;
  }
  // 4. Mouse threshold index
  res=LoadString(hDllInstance,STR_REGMOUSETHRESHOLDINDEX,cRegText,99);
  if (res>0)
  { valsize=sizeof(val); res=RegQueryValueEx(skey,cRegText,0,&valtype,(LPBYTE)&val,&valsize);
    if (res==ERROR_SUCCESS) mousethresholdindex=val;
    if (mousethresholdindex>3) mousethresholdindex=3;
  }
  // 5. Mouse corners
  res=LoadString(hDllInstance,STR_REGMOUSECORNERS,cRegText,99);
  if (res>0)
  { char c[5];
    valsize=5; res=RegQueryValueEx(skey,cRegText,0,&valtype,(LPBYTE)c,&valsize);
    if (res==ERROR_SUCCESS)
    { for (int i=0; i<4; i++)
      { switch (c[i]) {
          case (action_now_char): corner[i]=action_now; break;
          case (action_never_char): corner[i]=action_never; break;
          default: corner[i]=action_default;
        }
      }
	 }
  }
  // 6. Mute
  if (prefs.AllowMute)
  { res=LoadString(hDllInstance,STR_REGMUTESOUND,cRegText,99);
    if (res>0)
    { valsize=sizeof(val); res=RegQueryValueEx(skey,cRegText,0,&valtype,(LPBYTE)&val,&valsize);
      if (res==ERROR_SUCCESS) mute=(BOOL) val;
    }
  }
  // 7. ActiveConfig
  if (prefs.AllowActiveConfig)
  { res=LoadString(hDllInstance,STR_REGACTIVECONFIG,cRegText,99);
    if (res>0)
    { valsize=sizeof(val); res=RegQueryValueEx(skey,cRegText,0,&valtype,(LPBYTE)&val,&valsize);
      if (res==ERROR_SUCCESS) activeconfig=(BOOL) val;
    }
  }
  RegCloseKey(skey);
}

const char actionchar[]=  {action_default_char,action_now_char,action_never_char};

void TGeneralSettings::WriteRegistry()
{
  ScrDebugString("ScrPlus: GeneralDialog: WriteRegistry.");
  LONG res;
  HKEY skey;
  DWORD val;
  char cRegText[100];
  res=LoadString(hDllInstance,STR_REGSAVERSKEY,cRegText,99);
  if (res==0) return;
  DWORD disp;
  res=RegCreateKeyEx(HKEY_CURRENT_USER,cRegText,0,NULL,
                     REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL,&skey,&disp);
  if (res!=ERROR_SUCCESS) return;
  // 1. Password delay. There's not much to do with the error codes
  res=LoadString(hDllInstance,STR_REGPASSWORDDELAY,cRegText,99);
  if (res>0)
  { val=passworddelay; RegSetValueEx(skey,cRegText,0,REG_DWORD,(CONST BYTE*)&val,sizeof(val));
  }
  // 2. Password delay index
  res=LoadString(hDllInstance,STR_REGPASSWORDDELAYINDEX,cRegText,99);
  if (res>0)
  { val=passworddelayindex; RegSetValueEx(skey,cRegText,0,REG_DWORD,(CONST BYTE*)&val,sizeof(val));
  }
  // 3. Mouse threshold
  res=LoadString(hDllInstance,STR_REGMOUSETHRESHOLD,cRegText,99);
  if (res>0)
  { val=mousethreshold; RegSetValueEx(skey,cRegText,0,REG_DWORD,(CONST BYTE*)&val,sizeof(val));
  }
  // 4. Mouse threshold index
  res=LoadString(hDllInstance,STR_REGMOUSETHRESHOLDINDEX,cRegText,99);
  if (res>0)
  { val=mousethresholdindex;
    RegSetValueEx(skey,cRegText,0,REG_DWORD,(CONST BYTE*)&val,sizeof(val));
  }
  // 5. Mouse corners
  res=LoadString(hDllInstance,STR_REGMOUSECORNERS,cRegText,99);
  if (res>0)
  { char c[5]; for (int i=0; i<4; i++) c[i]=actionchar[corner[i]]; c[4]=0;
    RegSetValueEx(skey,cRegText,0,REG_SZ,(LPBYTE)c,5);
  }
  // 6. Mute
  if (prefs.AllowMute)
  { res=LoadString(hDllInstance,STR_REGMUTESOUND,cRegText,99);
    if (res>0)
    { val=mute; RegSetValueEx(skey,cRegText,0,REG_DWORD,(CONST BYTE*)&val,sizeof(val));
    }
  }
  // 7. ActiveConfig
  if (prefs.AllowActiveConfig)
  { res=LoadString(hDllInstance,STR_REGACTIVECONFIG,cRegText,99);
    if (res>0)
    { val=activeconfig; RegSetValueEx(skey,cRegText,0,REG_DWORD,(CONST BYTE*)&val,sizeof(val));
    }
  }

  RegCloseKey(skey);
}

void TGeneralSettings::NotifyChanges(HWND hwnd,BOOL isapply)
{ // Note that, if 'isapply' is TRUE, then there haven't actually
  // been any changes. It's more the 'notify' part that is relevant.
  // Corners will be sent to Sage immediately. But we do the full-blown
  // broadcast wininichange only when the user clicks on OK. Hopefully
  // this will minimise system disruption.
  if (!isapply)
  { LONG res; char c[200];
    ScrDebugString("Scrplus: GeneralDialog: Sage being notified of corners");
    res=LoadString(hDllInstance,STR_SAGENAME,c,99);
    if (res>0)
	 { HINSTANCE hsage=LoadLibrary(c);
      if (hsage!=NULL)
      { res=LoadString(hDllInstance,STR_SAGECHANGED,c,99);
        if (res>0)
        { SCREENSAVERCHANGED changedproc=(SCREENSAVERCHANGED) GetProcAddress(hsage,c);
          if (changedproc!=NULL) changedproc();
        }
        FreeLibrary(hsage);
      }
    }
    HINSTANCE hhots=LoadLibrary("ScrHots.dll");
    if (hhots!=NULL)
    { SCREENSAVERCHANGED changedproc=(SCREENSAVERCHANGED) GetProcAddress(hhots,"Screen_Saver_Changed");
      if (changedproc!=NULL) changedproc();
      FreeLibrary(hhots);
    }
  }
  if (isapply)
  { ScrDebugString("Scrplus: GeneralDialog: system being notified of changes");
    SendNotifyMessage(HWND_BROADCAST,WM_WININICHANGE,0,(LPARAM)"Windows");
  }
  // GeneralDialog sends on both changes and apply, to everything.
  // It's up to the recipient to decide what to do.
  WPARAM code;
  if (isapply) code=SCRCHANGE_GENERAL | SCRCHANGE_FROMAPPLY   | SCRCHANGE_TOBOTH;
  else         code=SCRCHANGE_GENERAL | SCRCHANGE_FROMCONTROL | SCRCHANGE_TOBOTH;
  HWND hsheet=GetParent(hwnd);
  HWND hdlg=GetParent(hsheet);
  TScrGeneralSettings sgi;
  sgi.cbSize=sizeof(sgi);
  sgi.corner[corner_nw]=corner[corner_nw]; sgi.corner[corner_ne]=corner[corner_ne];
  sgi.corner[corner_se]=corner[corner_se]; sgi.corner[corner_sw]=corner[corner_sw];
  sgi.mute=mute; sgi.mousethreshold=mousethreshold;
  sgi.passworddelay=passworddelay; sgi.activeconfig=activeconfig;
  TScrChangeRouter cr;
  cr.hsrcwnd=hsheet; cr.lParam=(LPARAM)&sgi; cr.code=code;
  SendMessage(hdlg,SCRM_CHANGE,0,(LPARAM)&cr);
}

void TGeneralSettings::Mark()
{ oldcorner[corner_nw]=corner[corner_nw]; oldcorner[corner_ne]=corner[corner_ne];
  oldcorner[corner_se]=corner[corner_se]; oldcorner[corner_sw]=corner[corner_sw];
  oldmute=mute;
  oldmousethreshold=mousethreshold;
  oldmousethresholdindex=mousethresholdindex;
  oldpassworddelay=passworddelay;
  oldpassworddelayindex=passworddelayindex;
  oldactiveconfig=activeconfig;
}

BOOL TGeneralSettings::Reset()
{ if ( corner[corner_nw]==oldcorner[corner_nw] && corner[corner_ne]==oldcorner[corner_ne]
    && corner[corner_se]==oldcorner[corner_se] && corner[corner_sw]==oldcorner[corner_sw]
    && mute==oldmute && mousethreshold==oldmousethreshold
    && mousethresholdindex==oldmousethresholdindex && passworddelay==oldpassworddelay
    && passworddelayindex==oldpassworddelayindex && activeconfig==oldactiveconfig)
    return FALSE;
  corner[corner_nw]=oldcorner[corner_nw]; corner[corner_ne]=oldcorner[corner_ne];
  corner[corner_se]=oldcorner[corner_se]; corner[corner_sw]=oldcorner[corner_sw];
  mute=oldmute;
  mousethreshold=oldmousethreshold;
  mousethresholdindex=oldmousethresholdindex;
  passworddelay=oldpassworddelay;
  passworddelayindex=oldpassworddelayindex;
  activeconfig=oldactiveconfig;
  return TRUE;
}

BOOL CheckHots()
{ BOOL b=FALSE;
  char cString[100];
  int res=LoadString(hDllInstance,STR_SAGENAME,cString,99);
  if (res>0)
  { HINSTANCE sagedll=LoadLibrary(cString);
	 if (sagedll!=NULL)
    { res=LoadString(hDllInstance,STR_SAGEDETECT,cString,99);
      if (res>0)
		{ SYSTEMAGENTDETECT detectproc=(SYSTEMAGENTDETECT) GetProcAddress(sagedll,cString);
        if (detectproc!=NULL) b=detectproc();
      }
    FreeLibrary(sagedll);
	 }
  }
  HINSTANCE hotsdll=LoadLibrary("ScrHots.dll");
  if (hotsdll!=NULL)
  { SYSTEMAGENTDETECT detectproc=(SYSTEMAGENTDETECT) GetProcAddress(hotsdll,"System_Agent_Detect");
    if (detectproc!=NULL) b=detectproc();
    FreeLibrary(hotsdll);
  }
  return b;
}


void TGeneralSettings::SetControls(HWND hwnd)
{ ignorechanges=TRUE;

  char cString[200];
  int res;
  // 0. Monitor control.
  LONG st=GetWindowLong(GetDlgItem(hwnd,ID_MONITOR),GWL_STYLE);
  st=st & (~(MS_CTOPLEFTMASK | MS_CTOPRIGHTMASK | MS_CBOTRIGHTMASK | MS_CBOTLEFTMASK));
  if (corner[corner_nw]==action_default) st|= MS_CTOPLEFTDEF;
  if (corner[corner_nw]==action_now)     st|= MS_CTOPLEFTNOW;
  if (corner[corner_nw]==action_never)   st|= MS_CTOPLEFTNEV;
  if (corner[corner_ne]==action_default) st|= MS_CTOPRIGHTDEF;
  if (corner[corner_ne]==action_now)     st|= MS_CTOPRIGHTNOW;
  if (corner[corner_ne]==action_never)   st|= MS_CTOPRIGHTNEV;
  if (corner[corner_se]==action_default) st|= MS_CBOTRIGHTDEF;
  if (corner[corner_se]==action_now)     st|= MS_CBOTRIGHTNOW;
  if (corner[corner_se]==action_never)   st|= MS_CBOTRIGHTNEV;
  if (corner[corner_sw]==action_default) st|= MS_CBOTLEFTDEF;
  if (corner[corner_sw]==action_now)     st|= MS_CBOTLEFTNOW;
  if (corner[corner_sw]==action_never)   st|= MS_CBOTLEFTNEV;
  SetWindowLong(GetDlgItem(hwnd,ID_MONITOR),GWL_STYLE,st);
  // 1. The instructional text message at the top
  sageok=CheckHots();
  ShowWindow(GetDlgItem(hwnd,ID_SAGEOK),sageok);
  ShowWindow(GetDlgItem(hwnd,ID_SAGEBAD),!sageok);
  // 2. The password-delay stuff
  if (prefs.AlwaysRequirePassword || prefs.NeverRequirePassword)
  { if (prefs.AlwaysRequirePassword) res=LoadString(hDllInstance,STR_ALWAYSREQUIREPASSWORD,cString,99);
	 else res=LoadString(hDllInstance,STR_NEVERREQUIREPASSWORD,cString,99);
	 if (res>0) SetDlgItemText(hwnd,ID_WAITSUMMARY,cString);
    else SetDlgItemText(hwnd,ID_WAITSUMMARY,"Special password treatment.");
	 ShowWindow(GetDlgItem(hwnd,ID_WAITDESC),SW_HIDE);
	 ShowWindow(GetDlgItem(hwnd,ID_WAITTEXT),SW_HIDE);
	 ShowWindow(GetDlgItem(hwnd,ID_WAITBUDDY),SW_HIDE);
	 ShowWindow(GetDlgItem(hwnd,ID_WAITBOX),SW_HIDE);
	 ShowWindow(GetDlgItem(hwnd,ID_WAITMOREDESC),SW_HIDE);
	 EnableWindow(GetDlgItem(hwnd,ID_WAITTEXT),FALSE);
	 EnableWindow(GetDlgItem(hwnd,ID_WAITBUDDY),FALSE);
	 EnableWindow(GetDlgItem(hwnd,ID_WAITBOX),FALSE);
	 ShowWindow(GetDlgItem(hwnd,ID_WAITSUMMARY),SW_SHOW);
  }
  else
  { ShowWindow(GetDlgItem(hwnd,ID_WAITSUMMARY),SW_HIDE);
	 SendDlgItemMessage(hwnd,ID_WAITBOX,CB_RESETCONTENT,0,0);
	 res=LoadString(hDllInstance,STR_SECONDS,cString,99);
	 if (res>0) SendDlgItemMessage(hwnd,ID_WAITBOX,CB_ADDSTRING,0,(LPARAM)cString);
	 res=LoadString(hDllInstance,STR_MINUTES,cString,99);
	 if (res>0) SendDlgItemMessage(hwnd,ID_WAITBOX,CB_ADDSTRING,0,(LPARAM)cString);
	 SendDlgItemMessage(hwnd,ID_WAITBOX,CB_SETCURSEL,passworddelayindex,0);
	 int n=passworddelay;
	 if (passworddelayindex==1) n=n/60;
	 wsprintf(cString,"%i",n);
	 SendDlgItemMessage(hwnd,ID_WAITTEXT,WM_SETTEXT,0,(LPARAM)cString);
    SendDlgItemMessage(hwnd,ID_WAITBUDDY,UDM_SETRANGE,0,MAKELONG(99,0));
  }
  // 3. The mouse thresold
  SendDlgItemMessage(hwnd,ID_THRESHOLD,CB_RESETCONTENT,0,0);
  char *c;
  res=LoadString(hDllInstance,STR_THRESHOLDHIGH,cString,99);
  if (res>0)
  { c=strrchr(cString,','); if (c!=NULL) *c=0;
    SendDlgItemMessage(hwnd,ID_THRESHOLD,CB_ADDSTRING,0,(LPARAM)cString);
  }
  res=LoadString(hDllInstance,STR_THRESHOLDNORMAL,cString,99);
  if (res>0)
  { c=strrchr(cString,','); if (c!=NULL) *c=0;
    SendDlgItemMessage(hwnd,ID_THRESHOLD,CB_ADDSTRING,0,(LPARAM)cString);
  }
  res=LoadString(hDllInstance,STR_THRESHOLDLOW,cString,99);
  if (res>0)
  { c=strrchr(cString,','); if (c!=NULL) *c=0;
    SendDlgItemMessage(hwnd,ID_THRESHOLD,CB_ADDSTRING,0,(LPARAM)cString);
  }
  res=LoadString(hDllInstance,STR_THRESHOLDIGNORE,cString,99);
  if (res>0)
  { c=strrchr(cString,','); if (c!=NULL) *c=0;
    SendDlgItemMessage(hwnd,ID_THRESHOLD,CB_ADDSTRING,0,(LPARAM)cString);
  }
  SendDlgItemMessage(hwnd,ID_THRESHOLD,CB_SETCURSEL,mousethresholdindex,0);
  // 4. Mute
  CheckDlgButton(hwnd,ID_MUTE,mute);
  if (prefs.AllowMute)
  { ShowWindow(GetDlgItem(hwnd,ID_MUTE),SW_SHOW);
    EnableWindow(GetDlgItem(hwnd,ID_MUTE),TRUE);
  }
  else
  { ShowWindow(GetDlgItem(hwnd,ID_MUTE),SW_HIDE);
    EnableWindow(GetDlgItem(hwnd,ID_MUTE),FALSE);
  }
  // 5. ActiveConfig
  CheckDlgButton(hwnd,ID_ACTIVECONFIG,activeconfig);
  if (prefs.AllowActiveConfig)
  { ShowWindow(GetDlgItem(hwnd,ID_ACTIVECONFIG),SW_SHOW);
    EnableWindow(GetDlgItem(hwnd,ID_ACTIVECONFIG),TRUE);
  }
  else
  { ShowWindow(GetDlgItem(hwnd,ID_ACTIVECONFIG),SW_HIDE);
    EnableWindow(GetDlgItem(hwnd,ID_ACTIVECONFIG),FALSE);
  }

  ignorechanges=FALSE;
}

void TGeneralSettings::GetControls(HWND hwnd)
{ if (ignorechanges) return;

  BOOL ischanged=FALSE;
  LONG res; char c[100]; unsigned int i;
  // 0. Monitor control
  TCorners nc;
  LONG st=GetWindowLong(GetDlgItem(hwnd,ID_MONITOR),GWL_STYLE);
  switch (st&MS_CTOPLEFTMASK)
  { case MS_CTOPLEFTNOW: nc[corner_nw]=action_now; break;
    case MS_CTOPLEFTNEV: nc[corner_nw]=action_never; break;
    default: nc[corner_nw]=action_default;
  } if (nc[corner_nw]!=corner[corner_nw]) ischanged=TRUE; corner[corner_nw]=nc[corner_nw];
  switch (st&MS_CTOPRIGHTMASK)
  { case MS_CTOPRIGHTNOW: nc[corner_ne]=action_now; break;
    case MS_CTOPRIGHTNEV: nc[corner_ne]=action_never; break;
    default: nc[corner_ne]=action_default;
  } if (nc[corner_ne]!=corner[corner_ne]) ischanged=TRUE; corner[corner_ne]=nc[corner_ne];
  switch (st&MS_CBOTRIGHTMASK)
  { case MS_CBOTRIGHTNOW: nc[corner_se]=action_now; break;
    case MS_CBOTRIGHTNEV: nc[corner_se]=action_never; break;
    default: nc[corner_se]=action_default;
  } if (nc[corner_se]!=corner[corner_se]) ischanged=TRUE; corner[corner_se]=nc[corner_se];
  switch (st&MS_CBOTLEFTMASK)
  { case MS_CBOTLEFTNOW: nc[corner_sw]=action_now; break;
    case MS_CBOTLEFTNEV: nc[corner_sw]=action_never; break;
    default: nc[corner_sw]=action_default;
  } if (nc[corner_sw]!=corner[corner_sw]) ischanged=TRUE; corner[corner_sw]=nc[corner_sw];
  // 2. Password delay stuff
  res=SendDlgItemMessage(hwnd,ID_WAITBOX,CB_GETCURSEL,0,0);
  if (res!=CB_ERR) { if ((unsigned int)res!=passworddelayindex) ischanged=TRUE; passworddelayindex=res; }
  SendDlgItemMessage(hwnd,ID_WAITTEXT,WM_GETTEXT,99,(LPARAM)c);
  res=sscanf(c,"%i",&i);
  if (res>0)
  { if (passworddelayindex==1) i=i*60;
    if (i!=passworddelay) ischanged=TRUE; passworddelay=i;
  }
  // 3. Mouse threshold
  res=SendDlgItemMessage(hwnd,ID_THRESHOLD,CB_GETCURSEL,0,0);
  if (res!=CB_ERR)
  { if ((unsigned int)res!=mousethresholdindex) ischanged=TRUE;
    mousethresholdindex=res;
    int index=res+STR_THRESHOLDFIRST;
    if (index<STR_THRESHOLDFIRST) index=STR_THRESHOLDFIRST;
    if (index>STR_THRESHOLDLAST) index=STR_THRESHOLDLAST;
    res=LoadString(hDllInstance,index,c,99);
    if (res>0)
	 { char *comma=strrchr(c,',');
      if (comma!=NULL)
      { comma=comma+1;
        res=sscanf(comma,"%i",&i);
        if (res>0)
        { if (i!=mousethreshold) ischanged=TRUE; mousethreshold=i; }
      }
    }
  }
  // 4. Mute
  if (prefs.AllowMute)
  { res=SendDlgItemMessage(hwnd,ID_MUTE,BM_GETSTATE,0,0); BOOL newBOOL;
    if (res & BST_CHECKED) newBOOL=TRUE; else newBOOL=FALSE;
    if (newBOOL!=mute) ischanged=TRUE; mute=newBOOL;
  }
  // 5. ActiveConfig
  if (prefs.AllowActiveConfig)
  { res=SendDlgItemMessage(hwnd,ID_ACTIVECONFIG,BM_GETSTATE,0,0); BOOL newBOOL;
    if (res & BST_CHECKED) newBOOL=TRUE; else newBOOL=FALSE;
    if (newBOOL!=activeconfig) ischanged=TRUE; activeconfig=newBOOL;
  }
  if (ischanged)
  { ScrDebugString("ScrPlus: GeneralDialog: a control has been changed. Doing registry stuff.");
	 WriteRegistry();
    NotifyChanges(hwnd,FALSE);
    // I'd like only to broadcast a WININI_CHANGE message if it's absolutely
    // needed, and it would seem OK to resrict it only to corners changing,
    // but I've had cold feet
  }
}



BOOL CALLBACK ScreenSaverConfigureDialog(HWND hwnd,UINT msg,WPARAM,LPARAM lParam)
{ switch (msg) {
    case (WM_INITDIALOG):
      {

  SetWindowLong(hwnd,GWL_USERDATA,lParam); // This is TRUE or FALSE, for activeconfig or not
  SetWindowLong(hwnd,DWL_USER,0); // this will be used for property-sheet subclassing
  char cSettingsDlgTitle[100];
  int count=LoadString(hScrInstance,STR_SETTINGSDLGTITLE,(LPSTR)&cSettingsDlgTitle,99);
  if (count==0) LoadString(hDllInstance,STR_SETTINGSDLGTITLE,(LPSTR)&cSettingsDlgTitle,99);
  HICON hAppIcon=LoadIcon(hScrInstance,MAKEINTRESOURCE(ICON_APP));
  if (hAppIcon==NULL) hAppIcon=LoadIcon(hDllInstance,MAKEINTRESOURCE(ICON_APP));
  if (hAppIcon==NULL) hAppIcon=LoadIcon(hScrInstance,MAKEINTRESOURCE(ICON_SCRAPP));
  if (hAppIcon==NULL) hAppIcon=LoadIcon(hDllInstance,MAKEINTRESOURCE(ICON_SCRAPP));
  if (hAppIcon!=NULL) SendMessage(hwnd,WM_SETICON,TRUE,(LPARAM)hAppIcon);
  // Note: for the title, we first give the user a chance and otherwise revert to
  // the default. Likewise the icon.
  // We do a SetIcon here to set the icon of the invisible parent, so it looks
  // right when you're alt-tabbing
  HICON hSmallIcon=(HICON) LoadImage(hScrInstance,MAKEINTRESOURCE(ICON_APP),IMAGE_ICON,16,16,0);
  if (hSmallIcon==NULL) hSmallIcon=(HICON) LoadImage(hDllInstance,MAKEINTRESOURCE(ICON_APP),IMAGE_ICON,16,16,0);
  if (hSmallIcon==NULL) hSmallIcon=(HICON) LoadImage(hScrInstance,MAKEINTRESOURCE(ICON_SCRAPP),IMAGE_ICON,16,16,0);
  if (hSmallIcon==NULL) hSmallIcon=(HICON) LoadImage(hDllInstance,MAKEINTRESOURCE(ICON_SCRAPP),IMAGE_ICON,16,16,0);

  // Now set up the default property sheet
  PROPSHEETHEADER psh;
  LPPROPSHEETPAGE psp;
  int numpages=2; // This is just a default. If the user wants more, they can
  // jolly well create more and copy stuff over.
  LPPROPSHEETPAGE pspages=new PROPSHEETPAGE[numpages];
  // Set up the general options page
  psp=&(pspages[0]);
  psp->dwSize=sizeof(*psp);
  psp->dwFlags=PSP_DEFAULT;
  psp->hInstance=hDllInstance; // This is where to load dialog box, icon or title string resource
  psp->pszTemplate=MAKEINTRESOURCE(DLG_GENERAL);
  psp->hIcon=NULL;  // ignored
  psp->pszTitle=NULL; // ignored
  psp->pfnDlgProc=GeneralDlgProc;
  TGeneralSettings *gs;
  gs=new TGeneralSettings(); // It's constructor loads the registry automatically
  // We can create an object on the stack, because we execute the dialog
  // inside the scope of this procedure
  psp->lParam=(LPARAM) gs;
  // Set up the overall property sheet
  psh.dwSize=sizeof(psh);
  psh.dwFlags=PSH_NOAPPLYNOW | PSH_PROPSHEETPAGE | PSH_USEHICON | PSH_USECALLBACK;
  psh.hwndParent=hwnd;
  psh.hInstance=hScrInstance; // so it's convenient for the user
  if (hSmallIcon==NULL) psh.hIcon=hAppIcon; else psh.hIcon=hSmallIcon;
  psh.pszCaption=cSettingsDlgTitle;
  psh.nPages=1;  // Although we say 1, there's still room for a second.
  psh.nStartPage=0;
  psh.ppsp=&(pspages[0]);
  psh.pfnCallback=PropertysheetCallback;
  // The responsibility for executing the thing is the user's
  ScrDebugString("ScrPlus: DoConfigDialog: about to ExecuteUserDialog");
  int res=p_config(hwnd,psh);
  ScrDebugString("ScrPlus: DoConfigDialog: completed ExecuteUserDialog... cleaning up");
  // Once it's finished, we're able to clean up immediately
  delete gs;
  delete[] pspages;
  if (hSmallIcon!=NULL) DestroyIcon(hSmallIcon);
  if (hAppIcon!=NULL) DestroyIcon(hAppIcon);
  // I think this foreground window stuff has something to do with
  // putting an EndDialog inside InitDialog. But I'm not sure.
  HWND hparwnd=GetParent(hwnd);
  if (hparwnd!=NULL && IsWindow(hparwnd)) SetForegroundWindow(hparwnd);
  EndDialog(hwnd,res);
  return TRUE;
      }

  case (SCRM_CHANGE):
  { // The code has additional bits to say if it's
	 // destination is SCRCHANGE_FULL or SCRCHANGE_PREVIEW.
    // Preview gets broadcast to all existing children
    // Full gets sent to the parent of this active config
    // If neither bit is set, then it is sent to both.
    // Here, if we are active, we just pass it on to the main window.
    TScrChangeRouter *cr=(TScrChangeRouter *)lParam;
    WPARAM code=cr->code;
    HWND hsrcwnd=cr->hsrcwnd;
    BOOL tofull=(code & SCRCHANGE_TOFULL);
    BOOL topreview=(code & SCRCHANGE_TOPREVIEW);
    if (!tofull && !topreview) {tofull=TRUE; topreview=TRUE;}
    TScrDialogInfo *di=(TScrDialogInfo *)GetWindowLong(hwnd,GWL_USERDATA);
	 BOOL isactive=di->IsAnActiveDialog;
    if (!isactive) tofull=FALSE;
    // NB. Must be a sendmessage, because of scope
    if (tofull) SendMessage(GetParent(hwnd),SCRM_CHANGE,code,cr->lParam);
    if (topreview && !prefs.DisablePreviewBroadcast)
    { // It's possible that the child is a dialog box with monitors,
      // or that it's a property sheet where each page might have a monitor
      // can't figure how how to do it at the moment
      // The main dialog (ie. me) should have only one child, but we might
      // as well go through all of them. For each child we check if it is
      // a dialog: if it is, then we look for an MonitorClass child, and if
      // we find one we send a message to it. Also if it is a dialog, then
      // we look through all of its children to see if they are dialogs.
      BroadcastChildMonitors(hsrcwnd,cr);
    }
    return TRUE;
  }

  default: return FALSE;
  }
}


BOOL CALLBACK BroadcastChildProc(HWND hwnd,LPARAM lParam)
{ TScrChangeRouter *cr=(TScrChangeRouter *)lParam;
  // First check if its a dialog; second if it's a monitor
  char c[50];
  GetClassName(hwnd,c,49);
  if (strcmp(c,"Dialog")==0) {BroadcastChildMonitors(hwnd,cr); return TRUE;}
  if (strcmp(c,MonitorClassName)!=0) return TRUE;
  // So, it's a monitor. First we try to get a child, which will be the
  // black screen window. Second we try to get the child of that, which will
  // be the screensaver preview window
  HWND hscreenwnd=GetWindow(hwnd,GW_CHILD);
  if (hscreenwnd==NULL) return TRUE;
  HWND hprevwnd=GetWindow(hscreenwnd,GW_CHILD);
  if (hprevwnd==NULL) return TRUE;
  SendMessage(hprevwnd,SCRM_CHANGE,cr->code,cr->lParam);
  return TRUE;
}

void BroadcastChildMonitors(HWND hparwnd,TScrChangeRouter *cr)
{
  EnumChildWindows(hparwnd,BroadcastChildProc,(LONG)cr);
}


//
// GeneralDlgProc is the dialog procedure for the 'general' page. On
// PSN_SETACTIVE it copies stuff into the controls. On any changes,
// it makes a note and saves it to the registry and notifies things.
// On PSN_KILLACTIVE it validates itself; on PSN_APPLY it remembers
// internally the current values; and on PSN_RESET it restores stuff
// (controls + internals) back to remembered values.
// It also does context help.
//
BOOL CALLBACK GeneralDlgProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{ switch (msg) {
	 case (WM_INITDIALOG):
	 { ScrDebugString("ScrPlus: GeneralDlgProc: WM_INITDIALOG. Setting up controls");
		LPPROPSHEETPAGE psp=(LPPROPSHEETPAGE)lParam;
		if (psp==NULL) return TRUE;
		TGeneralSettings *gs=(TGeneralSettings *)(psp->lParam);
		if (gs==NULL) return TRUE;
		SetWindowLong(hwnd,DWL_USER,(LONG)gs);
		gs->SetControls(hwnd);
		return TRUE;
	 }
	 case (WM_DESTROY):
	 { ScrDebugString("ScrPlus: GeneralDlgProc: WM_DESTROY - tidying up");
		return TRUE;
	 }
	 case (WM_COMMAND):
	 { HWND hctrlwnd=(HWND) lParam;
		if (hctrlwnd==NULL) return FALSE;
		// We don't bother checking the ID or the notification code.
		// GetControls will read all of the controls and see if any have
		// changed, and only if there have been changes will it write
		// to the registry.
		TGeneralSettings *gs=(TGeneralSettings *)GetWindowLong(hwnd,DWL_USER);
		if (gs==NULL) return FALSE;
      gs->GetControls(hwnd);
      return TRUE;
    }
    case (WM_NOTIFY):
    { LPNMHDR nmh=(LPNMHDR) lParam;
      UINT code=nmh->code;
      TGeneralSettings *gs=(TGeneralSettings *)GetWindowLong(hwnd,DWL_USER);
      if (gs==NULL) return TRUE;
      switch (code) {
        case (PSN_SETACTIVE):
		  { // set all the controls
          ScrDebugString("ScrPlus: GeneralDlgProc: PSN_SETACTIVE - nothing much");
          return TRUE;
        }
        case (PSN_KILLACTIVE):
        { // validate. If everything's OK, then SetWindowLong(DWL_MSGresult) to FALSE. Otherwise, True and display a message
          ScrDebugString("ScrPlus: GeneralDlgProc: PSN_KILLACTIVE - Validating. Everything is OK");
          SetWindowLong(hwnd,DWL_MSGRESULT,FALSE);
          return TRUE;
        }
        case (PSN_APPLY):
        { ScrDebugString("ScrPlus: GeneralDlgProc: PSN_APPLY - remembering current values");
          gs->Mark();
          gs->NotifyChanges(hwnd,TRUE);
          // Well, it's more of a Notify, because there won't in fact have been
          // any changes.
          return TRUE;
        }
        case (PSN_RESET):
        { // Revert back to old values
          ScrDebugString("ScrPlus: GeneralDlgProc: PSN_RESET - reverting back");
          BOOL anychanges=gs->Reset();
          if (anychanges)
			 { gs->WriteRegistry();
            gs->NotifyChanges(hwnd,FALSE);
          }
          return TRUE;
        }
        default: return FALSE;
      }
    }
    case (WM_HELP):
    { ScrDebugString("ScrPlus: GeneralDlgProc: WM_HELP");
      LPHELPINFO hi=(LPHELPINFO) lParam;
      char c[100];
      int res;
      HWND helpwnd=(HWND)hi->hItemHandle;
      UINT helpcommand=HELP_WM_HELP;
      DWORD helpstruct=(DWORD)GeneralHelpIds;
      if (hi->iCtrlId==ID_ACTIVECONFIG)
      { res=LoadString(hScrInstance,STR_SCRHELPFILE,c,99);
        if (res==0) res=LoadString(hDllInstance,STR_SCRHELPFILE,c,99);
        if (res>0) WinHelp(helpwnd,c,helpcommand,helpstruct);
      }
      else
      { res=LoadString(hScrInstance,STR_SCRHELPFILE,c,99);
		  if (res==0) res=LoadString(hDllInstance,STR_SCRHELPFILE,c,99);
        if (res==0)
        { res=LoadString(hDllInstance,STR_PLUSHELPFILE,c,99);
        }
        else
        { OFSTRUCT of;
          HFILE hfile=OpenFile(c,&of,OF_EXIST);
          if (hfile==HFILE_ERROR)
            res=LoadString(hDllInstance,STR_PLUSHELPFILE,c,99);
          else
            CloseHandle((HANDLE)hfile);

        }
        if (res>0) WinHelp(helpwnd,c,helpcommand,helpstruct);
      }
      return TRUE;
    }
    case (WM_CONTEXTMENU):
    { ScrDebugString("ScrPlus: GeneralDlgProc: WM_CONTEXTMENU");
      char c[100];
      int res;
      HWND helpwnd=(HWND)wParam;
      BOOL isactiveconfig=FALSE;
		if (helpwnd==GetDlgItem(hwnd,ID_ACTIVECONFIG)) isactiveconfig=TRUE;
      UINT helpcommand=HELP_CONTEXTMENU;
      DWORD helpstruct=(DWORD)GeneralHelpIds;
      if (isactiveconfig)
      { res=LoadString(hScrInstance,STR_SCRHELPFILE,c,99);
        if (res==0) res=LoadString(hDllInstance,STR_SCRHELPFILE,c,99);
        if (res>0) WinHelp(helpwnd,c,helpcommand,helpstruct);
      }
      else
      { res=LoadString(hScrInstance,STR_SCRHELPFILE,c,99);
        if (res==0) res=LoadString(hDllInstance,STR_SCRHELPFILE,c,99);
        if (res==0)
        { res=LoadString(hDllInstance,STR_PLUSHELPFILE,c,99);
        }
        else
        { OFSTRUCT of;
          HFILE hfile=OpenFile(c,&of,OF_EXIST);
          if (hfile==HFILE_ERROR)
            res=LoadString(hDllInstance,STR_PLUSHELPFILE,c,99);
          else
           CloseHandle((HANDLE)hfile);

        }
		  if (res>0) WinHelp(helpwnd,c,helpcommand,(DWORD)helpstruct);
      }
      return TRUE;
    }
    default: return FALSE;
  }
}


extern "C" void WINAPI ScrHelp(HWND hwnd,DWORD helpcommand,DWORD helptopic)
{ LibInit();
  ScrDebugString("ScrPlus: calling ScrHelp");
  LONG thisid=GetWindowLong(hwnd,GWL_ID);
  DWORD helpstruct[4];
  helpstruct[0]=thisid; helpstruct[1]=helptopic;
  helpstruct[2]=0; helpstruct[3]=0;
  char c[100];
  int res;
  if (helptopic==SCRHELP_ACTIVECONFIG)
  { res=LoadString(hScrInstance,STR_SCRHELPFILE,c,99);
    if (res==0) res=LoadString(hDllInstance,STR_SCRHELPFILE,c,99);
    if (res>0) WinHelp(hwnd,c,helpcommand,(DWORD)helpstruct);
  }
  else
  { res=LoadString(hScrInstance,STR_SCRHELPFILE,c,99);
    if (res==0) res=LoadString(hDllInstance,STR_SCRHELPFILE,c,99);
    if (res==0)
    { res=LoadString(hDllInstance,STR_PLUSHELPFILE,c,99);
    }
    else
    { OFSTRUCT of;
      HFILE hfile=OpenFile(c,&of,OF_EXIST);
      { if (hfile==HFILE_ERROR)
        res=LoadString(hDllInstance,STR_PLUSHELPFILE,c,99);
      }
    }
    if (res>0) WinHelp(hwnd,c,helpcommand,(DWORD)helpstruct);
  }
}



int CALLBACK PropertysheetCallback(HWND hwnd,UINT msg,LPARAM)
{ if (msg!=PSCB_INITIALIZED) return FALSE;
  // We normally do an about. But we don't if prefs say not to.
  if (prefs.DisableAbout) return FALSE;
  // Otherwise we do want it!
  char cString[100];
  int res=LoadString(hDllInstance,STR_ABOUTMENUITEM,cString,99);
  if (res>0)
  { HMENU hsysmenu=GetSystemMenu(hwnd,FALSE);
    if (hsysmenu!=NULL)
    { AppendMenu(hsysmenu,MF_SEPARATOR,1,"temp");
      AppendMenu(hsysmenu,MF_STRING,ID_ABOUT,cString);
    }
  }
  // Now set up the subclassing. The subclassing will remove itself
  // when it gets a WM_DESTROY
  LONG oldproc=SetWindowLong(hwnd,GWL_WNDPROC,(LONG)PropertysheetSubclassProc);
  SetWindowLong(GetParent(hwnd),DWL_USER,oldproc);
  return FALSE;
}

LRESULT CALLBACK PropertysheetSubclassProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{ WNDPROC oldproc=(WNDPROC) GetWindowLong(GetParent(hwnd),DWL_USER);
  switch (msg) {
    case WM_SYSCOMMAND:
    { if (wParam==ID_ABOUT)
      { p_about(hwnd);
		}
    } break;
    case WM_DESTROY:
    { SetWindowLong(hwnd,GWL_WNDPROC,(LONG)oldproc); } break; // cancel subclassing
  }
  if (oldproc==NULL) return DefWindowProc(hwnd,msg,wParam,lParam);
  else return CallWindowProc(oldproc,hwnd,msg,wParam,lParam);
}




HWND WINAPI ScrCreatePreview(HWND hwnd)
{ LibInit();
  if (hwnd==NULL) return NULL;
  HWND hparwnd=hwnd;
  char c[50];
  GetClassName(hparwnd,c,49);
  // The special testing of MonitorClass styles goes below.
  if (strcmp(c,MonitorClassName)==0)
  { LONG st=GetWindowLong(hwnd,GWL_STYLE);
    if ((st&MS_MONITORMASK)!=MS_PREVIEW)
    { ScrDebugString("CreatePreview: Cannot, because monitor has wrong style! Give it the MS_PREVIEW style.");
		ScrDebugBox(hwnd,"CreatePreview: Cannot, because monitor has wrong style! Give it the MS_PREVIEW style.","Programming error");
      return NULL;
    }
    HWND hchwnd=GetWindow(hparwnd,GW_CHILD);
    if (hchwnd==NULL)
    { ScrDebugString("CreatePreview: Internal error. No monitor-window window could be found.");
      ScrDebugBox(hwnd,"CreatePreview: No monitor-window window could be found.","Internal error");
      return NULL;
    }
    hparwnd=hchwnd;
  }
  return p_createpreview(hparwnd,TRUE);
}


int DoChangePasswdDialog(HWND hwnd) {return p_changepassword(hwnd);}

// DoPreview is for the preview in the main display settings control panel
int DoPreview(HWND hparwnd)
{ HWND hwnd=p_createpreview(hparwnd,FALSE);
  if (hwnd==NULL) return IDCANCEL;
  MSG msg;
  while (GetMessage(&msg, NULL, 0, 0))
  { TranslateMessage(&msg);
    DispatchMessage(&msg);
  }
  return msg.wParam;
}

int DoFullSave()
{ HWND hwnd=p_createfull();
  if (hwnd==NULL) return IDCANCEL;
  UINT oldval;
  SystemParametersInfo(SPI_SCREENSAVERRUNNING,1,&oldval,0);
  MSG msg;
  while (GetMessage(&msg, NULL, 0, 0))
  { TranslateMessage(&msg);
    DispatchMessage(&msg);
  }
  SystemParametersInfo(SPI_SCREENSAVERRUNNING,0,&oldval,0);
  return msg.wParam;
}




// Various different type-specific things start here



HWND NCreatePreview(HWND hparwnd, BOOL ismainpreview)
{ SIZE sz;
  RECT rc; GetWindowRect(hparwnd,&rc);
  sz.cx=rc.right-rc.left; sz.cy=rc.bottom-rc.top;
  LPARAM cp;
  if (ismainpreview) cp=SCRCREATE_MAINPREVIEW; else cp=SCRCREATE_CONFIGPREVIEW;
  TScrCreateStruct *scs=new TScrCreateStruct;
  scs->reserved=NULL;  scs->style=cp;
  return CreateWindowEx(0,SaverClassName,"SaverPreview",WS_CHILD | WS_VISIBLE,
                        0,0,sz.cx,sz.cy,
                        hparwnd,NULL,hScrInstance,(LPVOID)scs);
}

HWND XCreatePreview(HWND hparwnd, BOOL ismainpreview)
{ SIZE sz;
  RECT rc; GetWindowRect(hparwnd,&rc);
  sz.cx=rc.right-rc.left; sz.cy=rc.bottom-rc.top;
  LPARAM cp;
  if (ismainpreview) cp=SCRCREATE_MAINPREVIEW; else cp=SCRCREATE_CONFIGPREVIEW;
  TScrCreateStruct *scs=new TScrCreateStruct;
  scs->reserved=NULL; scs->style=cp;
  if (x_lucreatesaver==NULL) return CreateWindowEx(0,DefSaverClassName,"SaverPreview",WS_CHILD | WS_VISIBLE,0,0,sz.cx,sz.cy,hparwnd,NULL,hScrInstance,(LPVOID)scs);
  // otherwise, we have to give it stuff
  CREATESTRUCT cs;
  cs.lpCreateParams=(LPVOID) scs;
  cs.hInstance=hScrInstance;
  cs.hMenu=NULL;
  cs.hwndParent=hparwnd;
  cs.cy=sz.cy;
  cs.cx=sz.cx;
  cs.x=0;
  cs.y=0;
  cs.style=WS_CHILD | WS_VISIBLE;
  cs.lpszName="SaverPreview";
  cs.lpszClass=DefSaverClassName;
  cs.dwExStyle=0;
  return x_lucreatesaver((BOOL)cp,cs);
}

HWND WCreatePreview(HWND hparwnd, BOOL ismainpreview)
{ SIZE sz;
  RECT rc; GetWindowRect(hparwnd,&rc);
  sz.cx=rc.right-rc.left; sz.cy=rc.bottom-rc.top;
  LPARAM cp;
  if (ismainpreview) cp=SCRCREATE_MAINPREVIEW; else cp=SCRCREATE_CONFIGPREVIEW;
  TScrCreateStruct *scs=new TScrCreateStruct;
  scs->reserved=NULL; scs->style=cp;
  CREATESTRUCT cs;
  cs.lpCreateParams=(LPVOID)scs;
  cs.hInstance=hScrInstance;
  cs.hMenu=NULL;
  cs.hwndParent=hparwnd;
  cs.cy=sz.cy;
  cs.cx=sz.cx;
  cs.x=0;
  cs.y=0;
  cs.style=WS_CHILD | WS_VISIBLE;
  cs.lpszName="SaverPreview";
  cs.lpszClass=DefSaverClassName;
  cs.dwExStyle=0;
  LRESULT res;
  UINT msg;
  if (ismainpreview) msg=SCRAPP_LUCREATEMAINPREVIEW; else msg=SCRAPP_LUCREATECONFIGPREVIEW;
  res=SendMessage(w_hwnd,msg,(WPARAM)cp,(LPARAM)&cs);
  if (res!=0) return (HWND)res;
  res=SendMessage(w_hwnd,SCRAPP_LUCREATEPREVIEW,(WPARAM)cp,(LPARAM)&cs);
  if (res!=0) return (HWND)res;
  res=SendMessage(w_hwnd,SCRAPP_LUCREATESAVER,(WPARAM)cp,(LPARAM)&cs);
  if (res!=0) return (HWND)res;
  return CreateWindowEx(0,DefSaverClassName,"SaverPreview",WS_CHILD | WS_VISIBLE,0,0,sz.cx,sz.cy,hparwnd,NULL,hScrInstance,(LPVOID)scs);
}


HWND NCreateFull()
{ SIZE sz;
  sz.cx=GetSystemMetrics(SM_CXSCREEN); sz.cy=GetSystemMetrics(SM_CYSCREEN);
  DWORD exstyle;
  DWORD style;
  if (prefs.IsDebug)
  { sz.cx=sz.cx/6; sz.cy=sz.cy/6;
    exstyle=0;
    style=WS_OVERLAPPEDWINDOW | WS_VISIBLE;
  }
  else
  { exstyle=WS_EX_TOPMOST;
    style=WS_POPUP | WS_VISIBLE;
  }
  TScrCreateStruct *scs=new TScrCreateStruct;
  scs->reserved=NULL; scs->style=SCRCREATE_FULL;
  return CreateWindowEx(exstyle,SaverClassName,"SaverWindow",style,0,0,sz.cx,sz.cy,NULL,NULL,hScrInstance,(LPVOID)scs);
}

HWND XCreateFull()
{ SIZE sz;
  sz.cx=GetSystemMetrics(SM_CXSCREEN); sz.cy=GetSystemMetrics(SM_CYSCREEN);
  DWORD exstyle;
  DWORD style;
  if (prefs.IsDebug)
  { sz.cx=sz.cx/6; sz.cy=sz.cy/6;
    exstyle=0;
    style=WS_OVERLAPPEDWINDOW | WS_VISIBLE;
  }
  else
  { exstyle=WS_EX_TOPMOST;
    style=WS_POPUP | WS_VISIBLE;
  }
  if (x_lucreatesaver==NULL)
  { TScrCreateStruct *scs=new TScrCreateStruct;
    scs->reserved=NULL; scs->style=SCRCREATE_FULL;
    return CreateWindowEx(exstyle,DefSaverClassName,"SaverWindow",style,0,0,sz.cx,sz.cy,NULL,NULL,hScrInstance,(LPVOID)scs);
  }
  TScrCreateStruct *scs=new TScrCreateStruct;
  scs->reserved=NULL; scs->style=SCRCREATE_FULL;
  CREATESTRUCT cs;
  cs.lpCreateParams=(LPVOID)scs;
  cs.hInstance=hScrInstance;
  cs.hMenu=NULL;
  cs.hwndParent=NULL;
  cs.cy=sz.cy;
  cs.cx=sz.cx;
  cs.x=0;
  cs.y=0;
  cs.style=style;
  cs.lpszName="SaverWindow";
  cs.lpszClass=DefSaverClassName;
  cs.dwExStyle=exstyle;
  return x_lucreatesaver((BOOL)SCRCREATE_FULL,cs);
}

HWND WCreateFull()
{ SIZE sz;
  sz.cx=GetSystemMetrics(SM_CXSCREEN); sz.cy=GetSystemMetrics(SM_CYSCREEN);
  DWORD exstyle;
  DWORD style;
  if (prefs.IsDebug)
  { sz.cx=sz.cx/6; sz.cy=sz.cy/6;
    exstyle=0;
    style=WS_OVERLAPPEDWINDOW | WS_VISIBLE;
  }
  else
  { exstyle=WS_EX_TOPMOST;
    style=WS_POPUP | WS_VISIBLE;
  }
  TScrCreateStruct *scs=new TScrCreateStruct;
  scs->reserved=NULL; scs->style=SCRCREATE_FULL;
  CREATESTRUCT cs;
  cs.lpCreateParams=(LPVOID)scs;
  cs.hInstance=hScrInstance;
  cs.hMenu=NULL;
  cs.hwndParent=NULL;
  cs.cy=sz.cy;
  cs.cx=sz.cx;
  cs.x=0;
  cs.y=0;
  cs.style=style;
  cs.lpszName="SaverWindow";
  cs.lpszClass=DefSaverClassName;
  cs.dwExStyle=exstyle;
  LONG res;
  res=SendMessage(w_hwnd,SCRAPP_LUCREATEFULL,(WPARAM)SCRCREATE_FULL,(LPARAM)&cs);
  if (res!=0) return (HWND)res;
  res=SendMessage(w_hwnd,SCRAPP_LUCREATESAVER,(WPARAM)SCRCREATE_FULL,(LPARAM)&cs);
  if (res!=0) return (HWND)res;
  return CreateWindowEx(exstyle,DefSaverClassName,"SaverWindow",style,0,0,sz.cx,sz.cy,NULL,NULL,hScrInstance,(LPVOID)scs);
}


// TidyupNConfigProc:
// the purpose of this is as a wrapper around the user's dialogproc.
// It by default hides the ok and cancel buttons, so that the thing
// can go properly into a property sheet without any new changes on
// the part of the user.
BOOL CALLBACK TidyupNConfigProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{ if (msg==WM_INITDIALOG)
  { ShowWindow(GetDlgItem(hwnd,IDCANCEL),SW_HIDE);
    ShowWindow(GetDlgItem(hwnd,IDOK),SW_HIDE);
    EnableWindow(GetDlgItem(hwnd,IDCANCEL),FALSE);
    EnableWindow(GetDlgItem(hwnd,IDOK),FALSE);
  }
  return n_screensaverconfiguredialog(hwnd,msg,wParam,lParam);
}

int  NConfig(HWND,PROPSHEETHEADER &psh)
{ if (n_screensaverconfiguredialog==NULL)
      //return 0;
      return PropertySheetA(&psh);
  // Otherwise, we'll create a second page that has the user's thing on it
  // Remember that the default psh has room for one more
  LPPROPSHEETPAGE psp;
  psp=(LPPROPSHEETPAGE) &(psh.ppsp[1]);
  psp->dwSize=sizeof(*psp);
  psp->dwFlags=PSP_DEFAULT;
  psp->hInstance=hScrInstance; // This is where to load dialog box, icon or title string resource
  psp->pszTemplate=MAKEINTRESOURCE(DLG_SCRNSAVECONFIGURE);
  psp->hIcon=NULL;  // ignored
  psp->pszTitle=NULL; // ignored
  psp->pfnDlgProc=TidyupNConfigProc;
  psp->lParam=NULL;
  // Set up the overall property sheet
  psh.nPages=2;
  psh.nStartPage=1;
  return PropertySheet(&psh);
}

int  XConfig(HWND hwnd,PROPSHEETHEADER &psh)
  { TScrDialogInfo *di=(TScrDialogInfo *)GetWindowLong(hwnd,GWL_USERDATA);
	 BOOL isactive=di->IsAnActiveDialog;
	 if (x_luconfig!=NULL)
	 { int ret=x_luconfig(hwnd,psh,isactive);
		if (ret!=DLGCODE_DOSCRDEFAULT) return ret;
		}
	 return PropertySheet(&psh);
  }
int  WConfig(HWND hwnd,PROPSHEETHEADER &psh)
  { LRESULT res= SendMessage(w_hwnd,SCRAPP_LUCONFIG,(WPARAM)hwnd,(LPARAM)&psh);
    if (res==0)
      return PropertySheet(&psh);
     else
       return IDOK;
  }

BOOL CALLBACK AboutDlgProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM)
{ switch (msg) {
    case WM_INITDIALOG:
	 { char version[50];
      int res=ScrGetVersionString(version,49);
      HWND hwnd=GetDlgItem(hDlg,ID_VERSION);
      if (res!=0 && hwnd!=0)
      { char title[160];
        GetWindowText(hwnd,title,99);
        strcat(title," v");
        strcat(title,version);
        SetWindowText(hwnd,title);
      }
      return TRUE;
    }
    case WM_COMMAND:
    { switch (LOWORD(wParam)) {
        case IDOK: EndDialog(hDlg,IDOK); return TRUE;
        case IDCANCEL: EndDialog(hDlg,IDCANCEL); return TRUE;
        default: return FALSE;
      }
    }
    default: return FALSE;
  }
}

int  NAbout(HWND hwnd)
  { if (n_supplied_about)
      return DialogBox(hScrInstance,MAKEINTRESOURCE(DLG_ABOUT),hwnd,AboutDlgProc);
    else
      return DialogBox(hDllInstance,MAKEINTRESOURCE(DLG_ABOUTSCRPLUS),hwnd,AboutDlgProc);
  }
int  XAbout(HWND hwnd)
  { if (x_luabout!=NULL)
    { int ret=x_luabout(hwnd);
      if (ret!=DLGCODE_DOSCRDEFAULT) return ret;
    }
    return DialogBox(hDllInstance,MAKEINTRESOURCE(DLG_ABOUTSCRPLUS),hwnd,AboutDlgProc);
  }
int  WAbout(HWND hwnd)
  { LRESULT res=SendMessage(w_hwnd,SCRAPP_LUABOUT,(WPARAM)hwnd,0);
    if (res!=0) return IDOK;
    return DialogBox(hDllInstance,MAKEINTRESOURCE(DLG_ABOUTSCRPLUS),hwnd,AboutDlgProc);
  }

int  NChangePassword(HWND hwnd)
{ char c[100]; int res;
  if (prefs.NeverRequirePassword)
  { res=LoadString(hDllInstance,STR_NEVERREQUIREPASSWORD,c,99);
    if (res==0) strcpy(c,"Cannot change password");
    return MessageBox(hwnd,c,"Password",MB_OK);
  }
  res=LoadString(hDllInstance,STR_PASSREGNAME,c,99);
  if (res==0) return IDCANCEL;
  HINSTANCE hmpr=::LoadLibrary(c);
  if (hmpr==NULL) return IDCANCEL;
  res=LoadString(hDllInstance,STR_PWDCHANGEPASSWORD,c,99);
  if (res==0) {FreeLibrary(hmpr); return IDCANCEL;}
  PWDCHANGEPASSWORD PwdChangePassword=
       (PWDCHANGEPASSWORD)::GetProcAddress(hmpr,c);
  if (PwdChangePassword==NULL) {FreeLibrary(hmpr); return IDCANCEL;}
  res=LoadString(hDllInstance,STR_SCRPWDREGKEY,c,99);
  if (res==0) {FreeLibrary(hmpr); return IDCANCEL;}
  PwdChangePassword(c,hwnd,0,0);
  FreeLibrary(hmpr);
  return IDOK;
}

int  XChangePassword(HWND hwnd)
  { if (x_luchangepassword!=NULL)
    { int ret=x_luchangepassword(hwnd);
      if (ret!=DLGCODE_DOSCRDEFAULT) return ret;
    }
    return NChangePassword(hwnd);
  }

int  WChangePassword(HWND hwnd)
  { LRESULT res=SendMessage(w_hwnd,SCRAPP_LUCHANGEPASSWORD,(WPARAM)hwnd,0);
    if (res!=0) return IDOK;
    return NChangePassword(hwnd);
  }


// This is just put in for sake of completeness
LRESULT CALLBACK DefScreenSaverAppProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{ LibInit();
  if (msg>=SCRAPP_FIRST && msg<=SCRAPP_LAST) return 0;
  else return DefWindowProc(hwnd,msg,wParam,lParam);
}


// This thread spins and sends SCRM_TIMER messages.
// (actually, they're SCRM_THREADTIMER param.)
// If it's called, then presumably prefs.EnableThreadTimer is TRUE
#ifdef __BORLANDC__
void ThreadFunction(void *lParam)
#endif
#ifdef _MSC_VER
unsigned int __stdcall ThreadFunction(void *lParam)
#endif
{ TThreadData *td=(TThreadData *)lParam;
  HWND hwnd=td->hwnd;
  BOOL mustquit=FALSE;
  BOOL isvalid;
  BOOL hadenough=FALSE;
  // isvalid is the signal from the outside; hadenough is the signal from
  // inside
  MSG msg;
  while (!mustquit)
  { // Before anything, check if hwnd is valid
    BOOL res;
	 // If we've had enough, then we know that we don't want to do anything
	 // more and are just waiting for the quit message so we can leave
	 if (hadenough)
	 { res=TRUE; GetMessage(&msg,NULL,0,0xFFFF);
	 }
	 else
	 { res=PeekMessage(&msg,NULL,0,0xFFFF,PM_REMOVE);
	 }
	 if (res)
	 { if (msg.message==WM_QUIT) mustquit=TRUE;
		else
		{ char c[100];
		  wsprintf(c,"Thread message: msg=%x wParam=%x lParam=%x",msg.message,msg.wParam,msg.lParam);
		  ScrDebugString(c);
		  ScrDebugBox(NULL,c,"Thread message");
		}
	 }
	 if (!mustquit && !hadenough)
	 { DWORD starttime,period,endtime; // This only mean something if isvalid.
		EnterCriticalSection(&td->critsec);
		isvalid=td->IsHwndValid;
		LeaveCriticalSection(&td->critsec);
		if (isvalid)
		{ starttime=GetTickCount();
        period=SendMessage(hwnd,SCRM_INTERNAL,SCRINTERNAL_THREADTIMER,0);
        endtime=GetTickCount();
        // Note: period 0 means no rest for the wicked. Any other period
        // means at least some Sleep(), even if it is just 0 to yield a
        // timeslice.
        // We put this inside the ciritical section to ensure that
        // 'isvalid' really is the case for the send message
      }
      // It's not so critical that hwnd is valid for us to sleep
      if (isvalid)
      {
        switch (period)
        { case 0: break;   // not even a sleep
          case INFINITE:
          { ScrDebugString("Thread: infinite delay specified, so posting a 'had enough'");
            hadenough=TRUE;
				PostMessage(hwnd,SCRM_INTERNAL,SCRINTERNAL_HADENOUGH,0);
          } break;
          default:
          { DWORD sleeptime=0;
            if (starttime+period>endtime) sleeptime=starttime+period-endtime;
            if (sleeptime==0) Sleep(0);
            else
            { DWORD res=WaitForSingleObject(td->hChangeEvent,sleeptime);
              if (res==WAIT_OBJECT_0) ResetEvent(td->hChangeEvent);
            }
          }
        }
      }
    }
  }          
  ScrDebugString("Thread coming to an end. Deleting threaddata");
  CloseHandle(td->hChangeEvent);
  delete td;
#ifdef _MSC_VER
  return 0;
#endif
}

void CreateTimerData(HWND hwnd)
{ HLOCAL hMem=LocalAlloc(LPTR,4);
  LPVOID mem=LocalLock(hMem);
  if (mem!=NULL)
  { TThreadData **ptd=(TThreadData **)mem;
    *ptd=NULL;
    LocalUnlock(hMem);
  }
  SetProp(hwnd,TIMERDATA_PROPNAME,hMem);
}

void SetTimerData(HWND hwnd,TThreadData *td)
{ HLOCAL hMem=GetProp(hwnd,TIMERDATA_PROPNAME);
  if (hMem==NULL)
  { CreateTimerData; hMem=GetProp(hwnd,TIMERDATA_PROPNAME);
    if (hMem==NULL) return;
  }
  LPVOID mem=LocalLock(hMem);
  if (mem!=NULL)
  { TThreadData **ptd=(TThreadData **)mem;
    *ptd=td;
    LocalUnlock(hMem);
  }
}

TThreadData *GetTimerData(HWND hwnd)
{ HLOCAL hMem=GetProp(hwnd,TIMERDATA_PROPNAME);
  if (hMem==NULL) return NULL;
  LPVOID mem=LocalLock(hMem);
  TThreadData *td=NULL;
  if (mem!=NULL)
  { TThreadData **ptd=(TThreadData **)mem;
    if (ptd!=NULL) td=*ptd;
    LocalUnlock(hMem);
  }
  return td;
}

void RemoveTimerData(HWND hwnd)
{ HLOCAL hMem=GetProp(hwnd,TIMERDATA_PROPNAME);
  if (hMem==NULL) return;
  LocalFree(hMem);
  RemoveProp(hwnd,TIMERDATA_PROPNAME);
}

//
// DefScreenSaverProc. Default behaviour is:
// WM_CREATE: sets up stuff like start mouse coord, and time
// WM_ACTIVATE, WM_ACTIVATEAPP, WM_NCACTIVATE: if full-screen and wParam is
//   FALSE (ie. being deactivated), posts a WM_CLOSE to try and close
// WM_SETCURSOR: if full screen, sets it to null
// WM_LBUTTONDOWN, WM_RBUTTONDOWN, WM_MBUTTONDOWN, WM_KEYDOWN, WM_KEYUP:
//   if full screen, does a WM_CLOSE
// WM_MOUSEMOVE: if full screen, checks new coord against orig coord and, if
//   moved too far, does a WM_CLOSE
// WM_DESTROY: deletes private data, and does a PostQuitMessage. (Not a WM_CLOSE
//   like the documentation says!)
// WM_SYSCOMMAND: returns FALSE if either SC_CLOSE or SC_SCREENSAVE
// SCRM_VERIFYPW: checks password in the Master Password Router
// WM_CLOSE: if preview, always yes. If full screen and is within password delay,
//   lets it close. If outside password delay, pops up the box and returns yes
//   or no. Also re-reads mouse origin.
// and a couple of things to cope with timers
// SCRM_TIMERMSG: on SCRTIMERMSG_GETLONG, SETLONG, default is to return 0 and do nothing
//   on SCRTIMER_THREADTIMER, it checks the GetLong and then sends the SCRM_TIMER
//   on SCRTIMER_HADENOUGH, it separates itself from the thread and posts it a quitmessage
//   on SCRTIMER_RESTARTTIMER, it starts the timer.
// SCRM_TIMER: returns INFINITE, to say that we're not using timers
// SCRM_CHANGE: If necessary, rereads general settings. Also wakes up the thread from its sleep, if necessary

LRESULT CALLBACK DefScreenSaverProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{ LibInit();
  BOOL isfull=FALSE;
  if (GetParent(hwnd)==NULL) isfull=TRUE;
  char *traceType;
  if (isfull) traceType="full DefSaverProc"; else traceType="preview DefSaverProc";
  switch (msg) {
    case (WM_CREATE):
	 {  ScrDebugString(traceType,"WM_CREATE...");
		 TGeneralSettings *gs=new TGeneralSettings();
		 // registry reading is done automatically
		 fwp.passworddelay=gs->passworddelay;
		 fwp.mousethreshold=gs->mousethreshold;
		 fwp.activeconfig=gs->activeconfig;
		 delete gs;
		 GetCursorPos(&(fwp.orig));
		 fwp.starttime=GetTickCount();
		 fwp.isdialogactive=FALSE;
       CREATESTRUCT *cs=(CREATESTRUCT *)lParam;
       TScrCreateStruct *scs=(TScrCreateStruct *)cs->lpCreateParams;
       if (scs!=NULL) delete scs; cs->lpCreateParams=NULL;
       CreateTimerData(hwnd);
		 if (!prefs.DisableThreadTimer) PostMessage(hwnd,SCRM_INTERNAL,SCRINTERNAL_CREATETIMER,0);
	 } break;
	 case (SCRM_DIALOG):
	 { fwp.isdialogactive=(BOOL)wParam;
	 } break;
	 case (SCRM_INTERNAL):
	 { switch (wParam)
		{ case SCRINTERNAL_CREATETIMER: ScrStartTimer(hwnd); break;
		  case SCRINTERNAL_HADENOUGH:
		  { if (!prefs.DisableThreadTimer)
			 { ScrDebugString("SCRINTERNAL_HADENOUGH: closing down thread...");
				TThreadData *td=GetTimerData(hwnd);
				if (td==NULL) // If it is null, then we have strange goings on.
				{ ScrDebugString("SCRINTERNAL_HADENOUGH: strangely, the timer has disappeared!");
				  ScrDebugBox(hwnd,"SCRINTERNAL_HADENOUGH: strangely, the timer has disappeared!","SCRTIMER error");
				}
				else
				{ EnterCriticalSection(&td->critsec);
				  td->IsHwndValid=FALSE;
				  LeaveCriticalSection(&td->critsec);
				  PostThreadMessage(td->idThread,WM_QUIT,0,0);
				}
				SetTimerData(hwnd,NULL);
				// but we don't actually delete it. That's left to the thread itself
			 }
		  } break;
		  case SCRINTERNAL_THREADTIMER:
		  { // perhaps this was still in the queue even after the WM_DESTROY
			 // if that was TRUE, then we don't want it
          if (!prefs.DisableThreadTimer)
			 { TThreadData *td=GetTimerData(hwnd);
				if (td!=NULL) return SendMessage(hwnd,SCRM_TIMER,wParam,lParam);
          }
        } break;
      }
	 } break;
	 case (SCRM_TIMER):
	 { ScrDebugString("******************************************************************************");
      ScrDebugString("** SCRM_TIMER: being turned off. If you want it to keep going, you must return its period.");
      ScrDebugString("******************************************************************************");
      return INFINITE;
    }
    case (WM_ACTIVATE): case (WM_ACTIVATEAPP): case (WM_NCACTIVATE):
    { // close the saver if the parameter is FALSE, unless we're in debug
      // mode in which case keep it up
      if (isfull && !prefs.IsDebug)
      { if (LOWORD(wParam)==WA_INACTIVE)
        { if (fwp.isdialogactive)
            ScrDebugString(traceType,"WM_ACTIVATE: but a dialog is active, so ignoring it.");
          else
			 { ScrDebugString(traceType,"WM_ACTIVATE: about to inactivate window, so sending Close");
            PostMessage(hwnd,WM_CLOSE,0,0);
          }
        }
      }
    } break;
	 case (WM_SETCURSOR):
    { if (isfull && !prefs.IsDebug) SetCursor(NULL);
      else SetCursor(LoadCursor(NULL,IDC_ARROW));
    } break;
    case (WM_KEYUP):
    { if (isfull) ScrDebugString(traceType,"WM_KEYUP: ignoring it");
    } break;
    case (WM_LBUTTONDOWN): case (WM_MBUTTONDOWN):
    { if (isfull)
		{ if (fwp.isdialogactive)
          ScrDebugString(traceType,"WM_LBUTTONDOWN: but a dialog is active, so ignoring it.");
        else
        { ScrDebugString(traceType,"WM_LBUTTONDOWN: sending Close");
          PostMessage(hwnd,WM_CLOSE,0,0);
        }
      }
    } break;
	 case (WM_RBUTTONDOWN):  case (WM_KEYDOWN):
    { if (isfull)
      {
        if (msg==WM_KEYDOWN)
        { if (wParam!=VK_CONTROL && wParam!=VK_SHIFT && wParam!=VK_SCROLL)
          { if (fwp.isdialogactive)
				  ScrDebugString("WM_KEYDOWN: Misc. key pressed, but active dialog, so ignoring it.");
            else
            { ScrDebugString("WM_KEYDOWN: Misc key pressed: sending Close");
              PostMessage(hwnd,WM_CLOSE,0,0);
				}
            return DefWindowProc(hwnd,msg,wParam,lParam);
          }
          else
				ScrDebugString("WM_KEYDOWN: active-config key pressed. Checking...");
		  }
		  else
			 ScrDebugString("WM_RBUTTONDOWN: active-config. checking...");
		  if (fwp.isdialogactive)
		  { ScrDebugString("WM_ACTIVE: but dialog is active, so ignoring");
			 return DefWindowProc(hwnd,msg,wParam,lParam);
		  }
		  if (!prefs.AllowActiveConfig || !fwp.activeconfig)
		  { ScrDebugString("WM_ACTIVE: but it's not enabled, so sending close");
			 PostMessage(hwnd,WM_CLOSE,0,0);
			 return DefWindowProc(hwnd,msg,wParam,lParam);
		  }
		  // Otherwise, we're here and we have to bring up an activeconfig dialog
		  ScrDebugString(traceType,"Starting active config dialog");
		  SendMessage(hwnd,SCRM_DIALOG,TRUE,0);
		  BOOL cancontinue=TRUE;
		  if (isregistered && prefs.CheckPasswordForActiveConfig)
		  { if (NeedPassword())
			 {	LRESULT lres=SendMessage(hwnd,SCRM_VERIFYPW,0,0);
				if (!lres) cancontinue=FALSE;
				else fwp.starttime=GetTickCount();
			 }
		  }
		  if (cancontinue) SendMessage(hwnd,SCRM_ACTIVECONFIG,0,0);
		  SendMessage(hwnd,SCRM_DIALOG,FALSE,0);
		  ScrDebugString(traceType,"Finished active config dialog");
		  GetCursorPos(&(fwp.orig));
		}
	 } break;
	 case (WM_MOUSEMOVE):
	 { if (isfull && !prefs.IsDebug)
		{ POINT pt;
        GetCursorPos(&pt);
        int x=pt.x-fwp.orig.x; if (x<0) x=-x;
        int y=pt.y-fwp.orig.y; if (y<0) y=-y;
        if (x>(int)fwp.mousethreshold || y>(int)fwp.mousethreshold)
		  { if (fwp.isdialogactive)
				ScrDebugString(traceType,"WM_MOUSEMOVE: but dialog active, so ignoring");
			 else
			 { ScrDebugString(traceType,"WM_MOUSEMOVE: gone beyond threshold, sending Close");
            PostMessage(hwnd,WM_CLOSE,0,0);
          }
        }
      }
    } break;
	 case (WM_DESTROY):
    { ScrDebugString(traceType,"WM_DESTROY: tidying up");
      ScrStopTimer(hwnd);
      RemoveTimerData(hwnd);
      // a QUIT message, not a close message like it says in the docs!
		BOOL doquitmessage;
      // Here we must post a quit message either if we are running full-screen,
      // or if we are a preview child inside the display property dialog.
      // But NOT when we are a regular preview window.
      if (isfull) doquitmessage=TRUE;
      else
      { char classname[100]; GetClassName(GetParent(hwnd),classname,99);
        if (strcmp(classname,MonitorWindowClassName)==0)
          doquitmessage=FALSE; // because was in a preview thing
        else
          doquitmessage=TRUE;
		}
      if (doquitmessage)
      { ScrDebugString(traceType,"POSTQUITMESSAGE from WM_DESTROY!!");
        PostQuitMessage(IDCANCEL);
      }
    } break;
	 case (WM_SYSCOMMAND):
    { if (isfull)
      { if (wParam==SC_SCREENSAVE)
        { ScrDebugString(traceType,"WM_SYSCOMMAND: gobbling up a SC_SCREENSAVE to stop a new saver from running.");
          return FALSE;
        }
		  if (wParam==SC_CLOSE)
        { if (prefs.IsDebug)
          { ScrDebugString(traceType,"WM_SYSCOMMAND: should be gobbling up a SC_CLOSE, but am not because we're in debug mode.");
          }
          else
          { ScrDebugString(traceType,"WM_SYSCOMMAND: gobbling up a SC_CLOSE");
            return FALSE;
          }
        }
      }
    } break;
	 case (SCRM_VERIFYPW):
	 { ScrDebugString(traceType,"SCRM_VERIFYPW: going to DoVerifyPwDialog");
		// Note that the isdialogactive has been set externally. This is so that
		// if the user overrides SCRM_VERIFYPW (or SCRM_ACTIVECONFIG), then
		// the flags will already have been set.
		int res=DoVerifyPwDialog(hwnd);
		if (res==IDOK)
		{ ScrDebugString("SCRM_VERIFYPW: DoVerifyPw returned IDOK: returning TRUE!");
		  return TRUE;
		}
		else
		{ ScrDebugString("SCRM_VERIFYPW: DoVerifyPw returned IDCANCEL: returning FALSE");
		  return FALSE;
		}
    }
    case (SCRM_ACTIVECONFIG):
    { // must bring up the dialog.
      ScrDebugString(traceType,"SCRM_ACTIVECONFIG: going to pop up activeconfig");
      DoConfigDialog(hwnd,TRUE);
      return TRUE;
    }
    case (SCRM_CHANGE):
    { if (!isfull) return TRUE;
		// That's because our 'fullscreen' is the only one to store any data
      if ((wParam&SCRCHANGE_GETCODE)!=SCRCHANGE_GENERAL) return TRUE;
      TScrGeneralSettings *scgi=(TScrGeneralSettings *)lParam;
		fwp.passworddelay=scgi->passworddelay;
		fwp.mousethreshold=scgi->mousethreshold;
		fwp.activeconfig=scgi->activeconfig;
		TThreadData *td=GetTimerData(hwnd);
		if (td!=NULL) SetEvent(td->hChangeEvent);
		return TRUE;
	 }
	 case (WM_CLOSE):
	 { if (isfull)
		{ if (fwp.isdialogactive)
		  { ScrDebugString(traceType,"WM_CLOSE: active dialog, so ignoring close request");
			 return FALSE;
		  }
		  ScrDebugString(traceType,"WM_CLOSE: maybe we need a password");
		  BOOL needpasswd=NeedPassword();
		  BOOL lres; // lres is TRUE if we're OK, and FALSE if we're not with the pw.
		  if (needpasswd)
		  { SendMessage(hwnd,SCRM_DIALOG,TRUE,0);
			 ScrDebugString(traceType,"WM_CLOSE: starting verify-password message");
			 lres=SendMessage(hwnd,SCRM_VERIFYPW,0,0);
			 ScrDebugString(traceType,"WM_CLOSE: ending verify-password message");
			 SendMessage(hwnd,SCRM_DIALOG,FALSE,0);
			 GetCursorPos(&(fwp.orig));
		  }
		  else
		  { lres=TRUE; // no password needed
		  }
		  if (!lres)
		  { ScrDebugString(traceType,"WM_CLOSE: not OK, so doing nothing");
		  }
		  else
		  { ScrDebugString(traceType,"WM_CLOSE: password OK, so doing a DestroyWindow");
			 DestroyWindow(hwnd);
		  }
		  return FALSE; // because we processed the message
		}
		else
		{ // if preview-window
        DestroyWindow(hwnd);
      } break;
    }
  }
  return DefWindowProc(hwnd,msg,wParam,lParam);
}



void WINAPI ScrStartTimer(HWND hwnd)
{ LibInit();
  if (!prefs.DisableThreadTimer)
  { ScrDebugString("ScrStartTimer: creating a timer...");
    TThreadData *td;
	 td=GetTimerData(hwnd);
	 if (td!=0) // If a timer was already there, we leave it
    { ScrDebugString("ScrStartTimer: cannot restart, because one was already there!");
    }
    else
	 { td=new TThreadData;
		SetTimerData(hwnd,td);
		ScrDebugString("ScrStartTimer: am able to work with timers!");
		InitializeCriticalSection(&td->critsec);
		td->hChangeEvent=CreateEvent(NULL,TRUE,FALSE,NULL);
		td->hwnd=hwnd;
		td->IsHwndValid=TRUE;
#ifdef __BORLANDC__
    // Borland have arguments in this order:
    // start-addr, stack-size, arg-list, security, create-flags, thread-id
		td->hThread=_beginthreadNT(ThreadFunction,4096,td,NULL,0,&(td->idThread));
#endif
#ifdef _MSC_VER
    // Visual C++ has arguments in this order:
    // security, stack-size, start-addr, arglist, initflag, thread-addr
    td->hThread=_beginthreadex(NULL,4096,ThreadFunction,td,0,&(td->idThread));
#endif
      // add it to the global thread list
      EnterCriticalSection(&ThreadCounterCritSec);
      TThreadList *oldnext=ThreadList;
      ThreadList=new TThreadList;
      ThreadList->hThread=(HANDLE)td->hThread;
      ThreadList->next=oldnext;
      LeaveCriticalSection(&ThreadCounterCritSec);
		// And we've already done the SetLong.
		HANDLE hThisT=GetCurrentThread();
		HANDLE hThatT=(HANDLE)td->hThread;
		int pr=GetThreadPriority(hThisT);
		SetThreadPriority(hThatT,pr-1);
		// Hopefully that will do it, and hopefully it won't matter
		// if we underflow by one.
	 }
  }
  else
  { ScrDebugString("ScrStartTimer: Timers have been turned off in the prefs: they are not being initialized");
  }
}

void WINAPI ScrStopTimer(HWND hwnd)
{ if (hwnd==NULL)
  { ScrDebugString("ScrStopTimer: hwnd is null!");
    return;
  }
  LibInit();
  if (prefs.DisableThreadTimer)
  { ScrDebugString("ScrStopTimer: Timers have been turned off: you can not destroy them.");
  }
  else
  { TThreadData *td=GetTimerData(hwnd);
	 if (td==NULL)
    { ScrDebugString("ScrStopTimer: the timer had already been destroyed. This isn't necessarily bad.");
    }
    else
    { ScrDebugString("ScrStopTimer: destroying timer...");
      EnterCriticalSection(&td->critsec);
      td->IsHwndValid=FALSE;
		LeaveCriticalSection(&td->critsec);
      // That will be enough to ensure that we never get any messages
      // from now on. Note that the thread's send(SCRM_TIMER) is
      // itself bracketed inside this critical section
      // So not even another sendmessage can get through
      //CloseHandle((HANDLE)td->hThread);
		PostThreadMessage(td->idThread,WM_QUIT,0,0);
		SetTimerData(hwnd,NULL);
	 }
  }
}




void WINAPI ScrGetGeneralSettings(TScrGeneralSettings *sgs)
{ LibInit();
  TGeneralSettings *gs=new TGeneralSettings();
  gs->ReadRegistry();
  sgs->corner[corner_nw]=gs->corner[corner_nw];
  sgs->corner[corner_ne]=gs->corner[corner_ne];
  sgs->corner[corner_se]=gs->corner[corner_se];
  sgs->corner[corner_sw]=gs->corner[corner_sw];
  sgs->mute=gs->mute;
  sgs->mousethreshold=gs->mousethreshold;
  sgs->passworddelay=gs->passworddelay;
  sgs->activeconfig=gs->activeconfig;
  delete gs;
}



BOOL NeedPassword()
{ if (isregistered && prefs.AlwaysRequirePassword) return TRUE;
  if (isregistered && prefs.NeverRequirePassword) return FALSE;
  ScrDebugString("NeedPassword? Checking the timer");
  DWORD time=GetTickCount()-fwp.starttime;
  if (time/1000 < fwp.passworddelay)
  { ScrDebugString("Nope, we're within the delay...");
	 return FALSE;
  }
  HKEY hkey;
  UINT usepassword; DWORD usepasswordsize=sizeof(usepassword);
  ScrDebugString("NeedPassword?: checking the registry");
  // First we test if we are going to use a password or not
  char c[100]; int res;
  res=LoadString(hDllInstance,STR_DESKTOPREGNAME,c,99);
  if (res==0)
  { ScrDebugString("NeedPassword: failed to load screensaver reg. key string. Aborting");
	 return FALSE;
  }
  long err=RegOpenKey(HKEY_CURRENT_USER,c,&hkey);
  if (err!=ERROR_SUCCESS)
  { ScrDebugString("NeedPassword: could not get screensaver reg. key. Aborting");
	 return FALSE;
  }
  res=LoadString(hDllInstance,STR_USEPWDKEY,c,99);
  if (res==0)
  { RegCloseKey(hkey);
    ScrDebugString("NeedPassword: failed to load 'usepw' key name. Aborting");
    return FALSE;
  }
  err=RegQueryValueEx(hkey,c,NULL,NULL,(LPBYTE)&usepassword,&usepasswordsize);
  RegCloseKey(hkey);
  if (err!=ERROR_SUCCESS)
  { ScrDebugString("NeedPassword: failed to get 'usepw' value from registry. Aborting");
    return FALSE;
  }
  if (usepassword)
  { ScrDebugString("NeedPassword: yes, we do need the password");
    return TRUE;
  }
  else
  { ScrDebugString("NeedPassword: no, we don't need the password");
    return FALSE;
  }
}


int DoVerifyPwDialog(HWND hwnd)
{ char c[100];
  ScrDebugString("DoVerifyPwDialog: using Master Password Router");
  int res=LoadString(hDllInstance,STR_PWDPROVIDERNAME,c,99);
  if (res==0)
  { ScrDebugString("DoVerifyPwDialog: failed to load pwdprovidername string. Aborting");
    return IDOK;
  }
  HINSTANCE hpwdcpl=::LoadLibrary(c);
  if (hpwdcpl==NULL)
  { ScrDebugString("DoVerifyPwDialog: unable to load pwdprovider library. Aborting");
    return IDOK;
  }
  VERIFYSCREENSAVEPWD VerifyScreenSavePwd;
  res=LoadString(hDllInstance,STR_VERIFYPWDPROC,c,99);
  if (res==0)
  { ScrDebugString("DoVerifyPwDialog: failed to load 'verifypw' string. Aborting");
    FreeLibrary(hpwdcpl);
    return IDOK;
  }
  VerifyScreenSavePwd=(VERIFYSCREENSAVEPWD) GetProcAddress(hpwdcpl,c);
  if (VerifyScreenSavePwd==NULL)
  { ScrDebugString("DoVerifyPwDialog: could not get verifypw proc address. Aborting");
    FreeLibrary(hpwdcpl);
    return IDOK;
  }
  // Finally!
  ShowCursor(TRUE);
  ScrDebugString("DoVerifyPwDialog: about to do VerifyScreenSavePwd...");
  BOOL bres=VerifyScreenSavePwd(hwnd);
  ShowCursor(FALSE);
  FreeLibrary(hpwdcpl);
  if (bres)
  { ScrDebugString("DoVerifyPwDialog: verifypwd returned TRUE!. Returing IDOK");
    return IDOK;
  }
  else
  { ScrDebugString("DoVerifyPwDialog: verifypwd returned FALSE. Returning IDCANCEL");
  return IDCANCEL;
  }
}




//////////////////////////////////////////////////////////////////////////////
// MONITOR CONTROL                                                          //
// -----------------                                                        //
//////////////////////////////////////////////////////////////////////////////

// Note: in the normal course of affairs, a monitor can only ever appear
// if somehow we have done a ExecuteScreenSaver(...)
// and in those cases, the global function variables will have been set up.
// But inside the resource workshop, we will not have done it and so the
// functions will not have been set up.
// This means that we can't expect them to be present.
// Also note that DllEntryPoint registers the monitor immediately as a global
// class, and calls InitProcess. This means that stuff like dimensions
// have been set up correctly.

LRESULT CALLBACK MonitorWindowWindowProc(HWND hwnd,UINT msg,WPARAM wParam, LPARAM lParam)
{ switch (msg) {
    case WM_ERASEBKGND:
    { HDC hdc=(HDC) wParam;
      RECT rc;
      GetClientRect (hwnd, &rc);
      FillRect (hdc, &rc, GetSysColorBrush(COLOR_BACKGROUND));
      return TRUE;
    }
    case WM_DESTROY:
    { HWND hprevchild=GetWindow(hwnd,GW_CHILD);
      if (hprevchild!=NULL) ScrStopTimer(hprevchild);
    } break;
  }
  return DefWindowProc(hwnd,msg,wParam,lParam);
}

// If it has the title MonitorCornersText, then it will make itself a
// corners-editing control; if it has the title MonitorPreview, then it
// will create a child for itself.
//
LRESULT CALLBACK MonitorWindowProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{ switch (msg) {
   case WM_CREATE:      MonitorCreate(hwnd); return 0;
   case WM_LBUTTONDOWN: MonitorLButtonDown(hwnd,LOWORD(lParam),HIWORD(lParam)); return 0;
   case WM_COMMAND:     MonitorCommand(hwnd,LOWORD(wParam)); return 0;
   case WM_PAINT:       MonitorPaint(hwnd); return 0;
  }
  return DefWindowProc(hwnd, msg, wParam, lParam);
}

// Move it so it's the right size for it's bitmap; and optionally create
// a preview window inside.
void MonitorCreate(HWND HWindow)
{ //MessageBeep(0);
  RECT mrc;
  GetWindowRect(HWindow,&mrc);
  if ((mrc.right-mrc.left != monitorsize.cx) || (mrc.bottom-mrc.top != monitorsize.cy))
  { POINT mo;
    mo.x=(mrc.left+mrc.right)/2; mo.y=(mrc.top+mrc.bottom)/2;
    ScreenToClient(GetParent(HWindow),&mo);
    mo.x=mo.x-monitorsize.cx/2;
    mo.y=mo.y-monitorsize.cy/2;
    MoveWindow(HWindow,mo.x,mo.y,monitorsize.cx,monitorsize.cy,FALSE);
  }
  LONG st=GetWindowLong(HWindow,GWL_STYLE);
  if ((st&MS_MONITORMASK)==MS_PREVIEW)
  { // create a child window here
    LONG id=GetWindowLong(HWindow,GWL_ID);
    // Share the same id
    CreateWindow(MonitorWindowClassName,"Monitor window",WS_CHILD | WS_VISIBLE,
                             rcscreen.left,rcscreen.top,rcscreen.right-rcscreen.left,rcscreen.bottom-rcscreen.top,
                             HWindow,(HMENU)id,hDllInstance,NULL);
  }
}


// LButtonDown to track a popup
// Note that checks are created and destroyed in the same procedure,
// so outside this procedure no menu will have any checks.
void MonitorLButtonDown(HWND HWindow,int mousex,int mousey)
{ POINT pt; pt.x=mousex; pt.y=mousey;
  int cn=-1;
  for (int i=0; i<4; i++)
    if (PtInRect(&(rc[i]),pt)) cn=i;
  if (cn==-1) return;
  HMENU hm=menu[cn];
  TCorners nc;
  LONG st=GetWindowLong(HWindow,GWL_STYLE);
  switch (st&MS_CTOPLEFTMASK)
  { case MS_CTOPLEFTNOW: nc[corner_nw]=action_now; break;
    case MS_CTOPLEFTNEV: nc[corner_nw]=action_never; break;
    default: nc[corner_nw]=action_default;
  }
  switch (st&MS_CTOPRIGHTMASK)
  { case MS_CTOPRIGHTNOW: nc[corner_ne]=action_now; break;
    case MS_CTOPRIGHTNEV: nc[corner_ne]=action_never; break;
    default: nc[corner_ne]=action_default;
  }
  switch (st&MS_CBOTRIGHTMASK)
  { case MS_CBOTRIGHTNOW: nc[corner_se]=action_now; break;
    case MS_CBOTRIGHTNEV: nc[corner_se]=action_never; break;
    default: nc[corner_se]=action_default;
  }
  switch (st&MS_CBOTLEFTMASK)
  { case MS_CBOTLEFTNOW: nc[corner_sw]=action_now; break;
    case MS_CBOTLEFTNEV: nc[corner_sw]=action_never; break;
    default: nc[corner_sw]=action_default;
  }
  CheckMenuItem(hm,nc[cn],MF_CHECKED | MF_BYPOSITION);
  ClientToScreen(HWindow,&pt);
  TrackPopupMenu(hm,TPM_LEFTALIGN | TPM_LEFTBUTTON,pt.x,pt.y,0,HWindow,NULL);
  CheckMenuItem(hm,nc[cn],MF_UNCHECKED | MF_BYPOSITION);
}

// There are four different menus for the four different corners.
void MonitorCommand(HWND HWindow,int cmd)
{ if (!sageok)
  { if (!givenwarning)
    { char text[100],title[100];
      int res=LoadString(hDllInstance,STR_NOSAGEWARNING,text,99);
      if (res>0)
      { res=LoadString(hDllInstance,STR_NOSAGETITLE,title,99);
        if (res>0) ::MessageBox(GetParent(HWindow),text,title,MB_ICONWARNING | MB_OK);
      }
      givenwarning=TRUE;
    }
    // But go on regardless
  }
  int cn=(cmd & menu_getcorner) >>8;
  int cv=(cmd & menu_getindex);
  if (cn<0 || cn>3) return;
  if (cv<0 || cv>2) return;

  TCorners nc;
  LONG st=GetWindowLong(HWindow,GWL_STYLE);
  switch (st&MS_CTOPLEFTMASK)
  { case MS_CTOPLEFTNOW: nc[corner_nw]=action_now; break;
    case MS_CTOPLEFTNEV: nc[corner_nw]=action_never; break;
    default: nc[corner_nw]=action_default;
  }
  switch (st&MS_CTOPRIGHTMASK)
  { case MS_CTOPRIGHTNOW: nc[corner_ne]=action_now; break;
    case MS_CTOPRIGHTNEV: nc[corner_ne]=action_never; break;
    default: nc[corner_ne]=action_default;
  }
  switch (st&MS_CBOTRIGHTMASK)
  { case MS_CBOTRIGHTNOW: nc[corner_se]=action_now; break;
    case MS_CBOTRIGHTNEV: nc[corner_se]=action_never; break;
    default: nc[corner_se]=action_default;
  }
  switch (st&MS_CBOTLEFTMASK)
  { case MS_CBOTLEFTNOW: nc[corner_sw]=action_now; break;
    case MS_CBOTLEFTNEV: nc[corner_sw]=action_never; break;
    default: nc[corner_sw]=action_default;
  }

  nc[cn]=(BYTE)cv;

  st=st & (~(MS_CTOPLEFTMASK | MS_CTOPRIGHTMASK | MS_CBOTRIGHTMASK | MS_CBOTLEFTMASK));
  if (nc[corner_nw]==action_default) st |= MS_CTOPLEFTDEF;
  if (nc[corner_nw]==action_now)     st |= MS_CTOPLEFTNOW;
  if (nc[corner_nw]==action_never)   st |= MS_CTOPLEFTNEV;
  if (nc[corner_ne]==action_default) st |= MS_CTOPRIGHTDEF;
  if (nc[corner_ne]==action_now)     st |= MS_CTOPRIGHTNOW;
  if (nc[corner_ne]==action_never)   st |= MS_CTOPRIGHTNEV;
  if (nc[corner_se]==action_default) st |= MS_CBOTRIGHTDEF;
  if (nc[corner_se]==action_now)     st |= MS_CBOTRIGHTNOW;
  if (nc[corner_se]==action_never)   st |= MS_CBOTRIGHTNEV;
  if (nc[corner_sw]==action_default) st |= MS_CBOTLEFTDEF;
  if (nc[corner_sw]==action_now)     st |= MS_CBOTLEFTNOW;
  if (nc[corner_sw]==action_never)   st |= MS_CBOTLEFTNEV;
  SetWindowLong(HWindow,GWL_STYLE,st);
  InvalidateRect(HWindow,NULL,FALSE);
  UpdateWindow(HWindow);
  SendMessage(GetParent(HWindow),WM_COMMAND,MAKEWPARAM(GetWindowLong(HWindow,GWL_ID),BN_CLICKED),(LPARAM)HWindow);
}



// Use double-buffering and a memory dc. If there is a child (ie. this
// will be used for a preview), then only draw the monitor. Otherwise,
// draw its corners as well.
void MonitorPaint(HWND HWindow)
{
  PAINTSTRUCT ps;
  LONG ost=GetWindowLong(HWindow,GWL_STYLE);
  BOOL drawcorners=FALSE;
  if ((ost&MS_MONITORMASK)==MS_CORNERS) drawcorners=TRUE;
  BeginPaint(HWindow,&ps);
  HDC hdc=ps.hdc;
  HDC objdc=CreateCompatibleDC(hdc);
  if (objdc!=NULL)
  { HDC memdc=CreateCompatibleDC(hdc);
    if (memdc!=NULL)
    { HBITMAP membitmap=CreateCompatibleBitmap(hdc,monitorsize.cx,monitorsize.cy);
      if (membitmap!=NULL)
      { HGDIOBJ oldmembmp=SelectObject(memdc,membitmap);
        BitBlt(memdc,0,0,monitorsize.cx,monitorsize.cy,hdc,0,0,SRCCOPY);
        HGDIOBJ oldobjbmp=NULL;
        if (bmmonitor!=NULL) oldobjbmp=SelectObject(objdc,bmmonitor);
        { BitBlt(memdc,0,0,monitorsize.cx,monitorsize.cy,objdc,monitorsize.cx,0,SRCAND);
          BitBlt(memdc,0,0,monitorsize.cx,monitorsize.cy,objdc,0,0,SRCINVERT);
          if (drawcorners)
          { TCorners nc;
            LONG st=GetWindowLong(HWindow,GWL_STYLE);
            switch (st&MS_CTOPLEFTMASK)
            { case MS_CTOPLEFTNOW: nc[corner_nw]=action_now; break;
              case MS_CTOPLEFTNEV: nc[corner_nw]=action_never; break;
              default: nc[corner_nw]=action_default;
            }
            switch (st&MS_CTOPRIGHTMASK)
            { case MS_CTOPRIGHTNOW: nc[corner_ne]=action_now; break;
              case MS_CTOPRIGHTNEV: nc[corner_ne]=action_never; break;
              default: nc[corner_ne]=action_default;
            }
            switch (st&MS_CBOTRIGHTMASK)
            { case MS_CBOTRIGHTNOW: nc[corner_se]=action_now; break;
              case MS_CBOTRIGHTNEV: nc[corner_se]=action_never; break;
              default: nc[corner_se]=action_default;
            }
            switch (st&MS_CBOTLEFTMASK)
            { case MS_CBOTLEFTNOW: nc[corner_sw]=action_now; break;
              case MS_CBOTLEFTNEV: nc[corner_sw]=action_never; break;
              default: nc[corner_sw]=action_default;
            }
            for (int i=0; i<4; i++)
            { int c=nc[i]; if (c<0) c=0; if (c>3) c=3;
              SelectObject(objdc,bmaction[c]);
              BitBlt(memdc,rc[i].left,rc[i].top,actionsize.cx,actionsize.cy,objdc,0,0,SRCCOPY);
            }
          }
        }
        if (oldobjbmp!=NULL) SelectObject(objdc,oldobjbmp);
        BitBlt(hdc,0,0,monitorsize.cx,monitorsize.cy,memdc,0,0,SRCCOPY);
        SelectObject(memdc,oldmembmp);
        DeleteObject(membitmap);
      }
      DeleteDC(memdc);
    }
    DeleteDC(objdc);
  }
  EndPaint(HWindow,&ps);
}












//////////////////////////////////////////////////////////////////////////////
// PROCESS AND REGISTERING CLASSES                                          //
// ---------------------------------                                        //
//////////////////////////////////////////////////////////////////////////////



int WINAPI ScrGetVersionString(char *destbuf,int maxlen)
{ LibInit();
  if (!IsADll)
  {  if (destbuf==NULL) return strlen(VERSIONS);
     lstrcpyn(destbuf,VERSIONS,maxlen);
     return strlen(destbuf);
  }
  int numcopied=0;
  DWORD hVersion;
  char fn[400];
  GetModuleFileName(hDllInstance,fn,399);
  DWORD vis=GetFileVersionInfoSize(fn,&hVersion);
  if (vis!=0)
  { void *vData;
    vData=(void *)new char[(UINT)vis];
    if (GetFileVersionInfo(fn,hVersion,vis,vData))
    { char vn[100];
      strcpy(vn,"\\VarFileInfo\\Translation");
      LPVOID transblock; UINT vsize;
      BOOL res=VerQueryValue(vData,vn,&transblock,&vsize);
      if (res)
      { // Swap the words so wsprintf will print the lang-charset in the correct format.
        *(DWORD *)transblock = MAKELONG(HIWORD(*(DWORD *)transblock), LOWORD(*(DWORD *)transblock));
        wsprintf(vn,"\\StringFileInfo\\%08lx\\%s",*(DWORD *)transblock,"FileVersion");
        char *ver;
        BOOL res=VerQueryValue(vData,vn,(LPVOID*)&ver,&vsize);
        if (res)
        { if (destbuf==NULL)
          { numcopied=strlen(ver)+1;
          }
          else
          { lstrcpyn(destbuf,ver,maxlen);
            numcopied=strlen(destbuf);
          }
        }
        else
        { numcopied=0;
        }
      }
    }
    delete vData;
  }
  return numcopied;
}


BOOL WINAPI DllEntryPoint(HINSTANCE h,DWORD reason,LPVOID)
{ IsADll=TRUE;
  switch (reason) {
	 case DLL_PROCESS_ATTACH: {hDllInstance=h; return InitProcess(); }
	 case DLL_PROCESS_DETACH: return CloseProcess();
  }
  return FALSE;
}


BOOL InitProcess()
{ islibinit=TRUE;
  // make sure it's run from the right place
  char fn[400];
  GetModuleFileName(hDllInstance,fn,399);
  char wd[400];
  GetWindowsDirectory(wd,399);
  int endslash=strlen(wd)-1;
  if (wd[endslash]!='\\') strcat(wd,"\\");
  strcat(wd,"scrplus.dll");
  fn[0]=' '; fn[1]=' ';
  wd[0]=' '; wd[1]=' ';
  // We set the drive letter on both the same, so that any drive
  // combination works.
  unsigned int lenfn=strlen(fn);
  unsigned int lenwd=strlen(wd);
  if (lenfn==CharUpperBuff(fn,lenfn))
  { if (lenwd==CharUpperBuff(wd,lenwd))
	 { // It'd be unfair to stop them running scrplus just because we
		// couldn't convert case properly
		if (strcmp(fn,wd)!=0)
		{ char err[2000];
		  int res=LoadString(hDllInstance,STR_WRONGINSTALLDIRECTORY,err,1999);
		  if (res==0) strcpy(err,"Wrong install directory. Put it in the windows directory");
		  CharLowerBuff(wd,lenwd);
		  strcat(err,"\r\n");
		  strcat(err,wd);
        if (IsADll)
        { MessageBox(NULL,err,"ScrPlus",MB_OK);
		    return FALSE;
        }
		}
	 }
  }


  // and now the process-global variables
  sageok=FALSE;
  givenwarning=FALSE;
  SetDefaultPrefs();
  for (int irect=0; irect<4; irect++)
  { SetRect(&(rc[irect]),0,0,0,0);
	 menu[irect]=NULL;
  }
  int res;
  for (int imenu=0; imenu<4; imenu++)
  { menu[imenu]=CreatePopupMenu();
	 char c[100];
	 res=LoadString(hDllInstance,STR_CORNERDEFAULT,c,99);
	 if (res>0) AppendMenu(menu[imenu],MF_STRING,menucorner[imenu]+action_default,c);
	 res=LoadString(hDllInstance,STR_CORNERNOW,c,99);
	 if (res>0) AppendMenu(menu[imenu],MF_STRING,menucorner[imenu]+action_now,c);
	 res=LoadString(hDllInstance,STR_CORNERNEVER,c,99);
	 if (res>0) AppendMenu(menu[imenu],MF_STRING,menucorner[imenu]+action_never,c);
  }
  bmmonitor=LoadBitmap(hDllInstance,MAKEINTRESOURCE(BMP_MONITOR));
  bmaction[action_default]=LoadBitmap(hDllInstance,MAKEINTRESOURCE(BMP_DEFAULT));
  bmaction[action_now]=LoadBitmap(hDllInstance,MAKEINTRESOURCE(BMP_NOW));
  bmaction[action_never]=LoadBitmap(hDllInstance,MAKEINTRESOURCE(BMP_NEVER));
  BITMAP bmp;
  GetObject(bmmonitor,sizeof(bmp),&bmp);
  // divide width by two because we have XOR and AND masks adjacent
  monitorsize.cx=bmp.bmWidth/2; monitorsize.cy=bmp.bmHeight;
  GetObject(bmaction[action_default],sizeof(bmp),&bmp);
  actionsize.cx=bmp.bmWidth; actionsize.cy=bmp.bmHeight;
  char c[100];
  res=LoadString(hDllInstance,STR_MONITORCORNERS,c,99);
  if (res>0)
  { int nw_x,nw_y,ne_x,ne_y,se_x,se_y,sw_x,sw_y;
    sscanf(c,"%i %i  %i %i  %i %i  %i %i",&nw_x,&nw_y,&ne_x,&ne_y,&se_x,&se_y,&sw_x,&sw_y);
    SetRect(&rc[corner_nw],nw_x,nw_y,nw_x+actionsize.cx,nw_y+actionsize.cy);
    SetRect(&rc[corner_ne],ne_x-actionsize.cx,ne_y,ne_x,ne_y+actionsize.cy);
    SetRect(&rc[corner_se],se_x-actionsize.cx,se_y-actionsize.cy,se_x,se_y);
    SetRect(&rc[corner_sw],sw_x,sw_y-actionsize.cy,sw_x+actionsize.cx,sw_y);
    SetRect(&rcscreen,nw_x,nw_y,se_x,se_y);
  }
  return RegisterControls();
}


BOOL CloseProcess()
{ ScrDebugString("ScrPlus: closing process...");
  if (!islibinit) {ScrDebugString("nothing to close!"); return TRUE;}
  if (bmmonitor!=NULL) DeleteObject(bmmonitor); bmmonitor=NULL;
  if (bmaction[action_default]!=NULL) DeleteObject(bmaction[action_default]); bmaction[action_default]=NULL;
  if (bmaction[action_now]!=NULL) DeleteObject(bmaction[action_now]); bmaction[action_now]=NULL;
  if (bmaction[action_never]!=NULL) DeleteObject(bmaction[action_never]); bmaction[action_never]=NULL;
  if (menu[0]!=NULL) DestroyMenu(menu[0]); menu[0]=NULL;
  if (menu[1]!=NULL) DestroyMenu(menu[1]); menu[1]=NULL;
  if (menu[2]!=NULL) DestroyMenu(menu[2]); menu[2]=NULL;
  if (menu[3]!=NULL) DestroyMenu(menu[3]); menu[3]=NULL;
  islibinit=FALSE;
  return UnregisterControls();
}


BOOL RegisterControls()
{
   WNDCLASSEX wcm;  // for window-class-of-monitor. The monitor thing itself
   wcm.cbSize=sizeof(wcm);
   wcm.style = CS_GLOBALCLASS;
   wcm.lpfnWndProc=MonitorWindowProc;
   wcm.cbClsExtra=0;
   wcm.cbWndExtra=0;  // stores its corners in STYLE
   wcm.hInstance=hDllInstance;
   wcm.hIcon=NULL;
   wcm.hCursor=NULL;
   wcm.hbrBackground=(HBRUSH)GetStockObject(NULL_BRUSH);
   wcm.lpszMenuName=NULL;
   wcm.lpszClassName = MonitorClassName;
   wcm.hIconSm=NULL;
   ATOM res=RegisterClassEx(&wcm);
   if (res==0)
   { ScrDebugString("ScrPlus: failed to register monitor class");
     ScrDebugBox(NULL,"Failed to register monitor class","Scrplus DLL");
     return FALSE;
   }
   WNDCLASSEX wcw;  // for window-class-of-monitor's-window
   wcw.cbSize=sizeof(wcw);
   wcw.style = CS_VREDRAW | CS_HREDRAW | CS_GLOBALCLASS;
   wcw.lpfnWndProc=MonitorWindowWindowProc;
   wcw.cbClsExtra=0;
   wcw.cbWndExtra=0;
   wcw.hInstance=hDllInstance;
   wcw.hIcon=NULL;
   wcw.hCursor=NULL;
   wcw.hbrBackground=(HBRUSH)GetStockObject(NULL_BRUSH);
   wcw.lpszMenuName=NULL;
   wcw.lpszClassName = MonitorWindowClassName;
   wcw.hIconSm=NULL;
   res=RegisterClassEx(&wcw);
   if (res==0)
	{ ScrDebugString("ScrPlus: Failed to register monitor window class");
     ScrDebugBox(NULL,"Failed to register monitor window class","Scrplus DLL");
     return FALSE;
   }
   ScrDebugString("ScrPlus: succesfully registered controls");
   return TRUE;
}

BOOL UnregisterControls()
{ BOOL success=TRUE;
  BOOL res=UnregisterClass(MonitorWindowClassName,hDllInstance);
  if (!res)
  { ScrDebugString("ScrPlus: failed to unregister monitor window class");
    ScrDebugBox(NULL,"Failed to unregister monitor window class","Scrplus");
    success=FALSE;
  }
  res=UnregisterClass(MonitorClassName,hDllInstance);
  if (!res)
  { ScrDebugString("ScrPlus: failed to unregister monitor class");
    ScrDebugBox(NULL,"Failed to unregister monitor class","ScrPlus");
    success=FALSE;
  }
  if (success) ScrDebugString("Scrplus: successfully unregistered controls");
  else ScrDebugString("Scrplus: error unregistering controls...");
  return success;
}





void LibInit()
{ if (islibinit) return;
  if (IsADll) return;
  if (hDllInstance!=NULL) return; // although I can't imagine why
  hDllInstance=GetModuleHandle(NULL);
  // CheckResources(); Actually, we won't do it here.
  InitProcess();
  return;
}

void LibClose()
{ if (!islibinit) return;
  CloseProcess();
}


void ScrDebugString(char *c)
{ if (!prefs.IsTrace) return;
  char d[200]; strcpy(d,c); strcat(d,"___________  \n\r"); OutputDebugString(d);
}

void ScrDebugString(char *a,char *b)
{ if (!prefs.IsTrace) return;
  char d[200]; strcpy(d,a); strcat(d,": "); strcat(d,b); strcat(d,"_________  \n\r"); OutputDebugString(d);
}

void ScrDebugBox(HWND hwnd,char *m,char *t)
{ if (!prefs.IsTrace) return;
  ::MessageBox(hwnd,m,t,MB_OK);
}







// This stuff below is handling for controls to appear in the workshop

INT CALLBACK ControlSizeToTextFunc(DWORD,DWORD,HFONT,LPSTR)
{ return monitorsize.cx; }

BOOL CALLBACK ControlStyleFunc(HWND hwnd,CCSTYLE *)
{ MessageBox(hwnd,"Function for changing style","Custom control",MB_OK);
  return TRUE;
}

extern "C" UINT CALLBACK CustomControlInfoA(CCINFO *cci)
{ if (cci==NULL) return 1;
  strcpy(cci->szClass,MonitorClassName);
  cci->flOptions=CCF_NOTEXT;
  strcpy(cci->szDesc,MonitorClassDesc);
  cci->cxDefault=monitorsize.cx; // will already have been initialized in InitDll
  cci->cyDefault=monitorsize.cy;
  cci->flStyleDefault=WS_CHILD | WS_VISIBLE | MS_PREVIEW;
  cci->flExtStyleDefault=0;
  cci->flCtrlTypeMask=MS_PREVIEW | MS_NOTHING | MS_CORNERS
                    | MS_CTOPLEFTDEF  | MS_CTOPLEFTNOW  | MS_CTOPLEFTNEV
                    | MS_CTOPRIGHTDEF | MS_CTOPRIGHTNOW | MS_CTOPRIGHTNEV
                    | MS_CBOTRIGHTDEF | MS_CBOTRIGHTNOW | MS_CBOTRIGHTNEV
                    | MS_CBOTLEFTDEF  | MS_CBOTLEFTNOW  | MS_CBOTLEFTNEV;
  strcpy(cci->szTextDefault,"");
  CCSTYLEFLAG csf[15];
  csf[0].flStyle=MS_NOTHING;      csf[0].flStyleMask=MS_MONITORMASK;  csf[0].pszStyle="MS_NOTHING";
  csf[ 1].flStyle=MS_PREVIEW;      csf[ 1].flStyleMask=MS_MONITORMASK;  csf[ 1].pszStyle="MS_PREVIEW";
  csf[ 2].flStyle=MS_CORNERS;      csf[ 2].flStyleMask=MS_MONITORMASK;  csf[ 2].pszStyle="MS_CORNERS";
  csf[ 3].flStyle=MS_CTOPLEFTDEF;  csf[ 3].flStyleMask=MS_CTOPLEFTMASK; csf[ 3].pszStyle="MS_CTOPLEFTDEF";
  csf[ 4].flStyle=MS_CTOPLEFTNOW;  csf[ 4].flStyleMask=MS_CTOPLEFTNOW;  csf[ 4].pszStyle="MS_CTOPLEFTNOW";
  csf[ 5].flStyle=MS_CTOPLEFTNEV;  csf[ 5].flStyleMask=MS_CTOPLEFTNEV;  csf[ 5].pszStyle="MS_CTOPLEFTNEV";
  csf[ 6].flStyle=MS_CTOPRIGHTDEF; csf[ 6].flStyleMask=MS_CTOPRIGHTMASK;csf[ 6].pszStyle="MS_CTOPRIGHTDEF";
  csf[ 7].flStyle=MS_CTOPRIGHTNOW; csf[ 7].flStyleMask=MS_CTOPRIGHTNOW; csf[ 7].pszStyle="MS_CTOPRIGHTNOW";
  csf[ 8].flStyle=MS_CTOPRIGHTNEV; csf[ 8].flStyleMask=MS_CTOPRIGHTNEV; csf[ 8].pszStyle="MS_CTOPRIGHTNEV";
  csf[ 9].flStyle=MS_CBOTRIGHTDEF; csf[ 9].flStyleMask=MS_CBOTRIGHTMASK;csf[ 9].pszStyle="MS_CBOTRIGHTDEF";
  csf[10].flStyle=MS_CBOTRIGHTNOW; csf[10].flStyleMask=MS_CBOTRIGHTNOW; csf[10].pszStyle="MS_CBOTRIGHTNOW";
  csf[11].flStyle=MS_CBOTRIGHTNEV; csf[11].flStyleMask=MS_CBOTRIGHTNEV; csf[11].pszStyle="MS_CBOTRIGHTNEV";
  csf[12].flStyle=MS_CBOTLEFTDEF;  csf[12].flStyleMask=MS_CBOTLEFTMASK; csf[12].pszStyle="MS_CBOTLEFTDEF";
  csf[13].flStyle=MS_CBOTLEFTNOW;  csf[13].flStyleMask=MS_CBOTLEFTNOW;  csf[13].pszStyle="MS_CBOTLEFTNOW";
  csf[14].flStyle=MS_CBOTLEFTNEV;  csf[14].flStyleMask=MS_CBOTLEFTNEV;  csf[14].pszStyle="MS_CBOTLEFTNEV";
  cci->cStyleFlags=15;
  cci->aStyleFlags=csf;
  cci->lpfnStyle=ControlStyleFunc;
  cci->lpfnSizeToText=ControlSizeToTextFunc;
  cci->dwReserved1=0;
  cci->dwReserved2=0;
  return 1;
}


